/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64;

import java.math.BigInteger;
import ru.ispras.microtesk.model.TemporaryVariables;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.memory.Memory;

/**
 * The {@code TempVars} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class TempVars extends TemporaryVariables {
  public final Memory tempCPR;
  public final Memory tempCP2CPR;
  public final Memory hint;
  public final Memory hint4b;
  public final Memory temp_bit;
  public final Memory temp6;
  public final Memory temp;
  public final Memory temp0;
  public final Memory temp1;
  public final Memory temp2;
  public final Memory temp3;
  public final Memory tempI;
  public final Memory temp64;
  public final Memory temp64_0;
  public final Memory temp64_1;
  public final Memory temp64_2;
  public final Memory temp64_3;
  public final Memory tempL;
  public final Memory temp_fp_s;
  public final Memory temp_fp_s2;
  public final Memory temp_fp_d;
  public final Memory temp_fp_d2;
  public final Memory temp128;
  public final Memory temp128_0;
  public final Memory temp128_1;
  public final Memory temp128_2;
  public final Memory temp33;
  public final Memory temp65;
  public final Memory op_encoding;
  public final Memory todo_fpu;
  public final Memory fmt_fpu;
  public final Memory fmt3_fpu;
  public final Memory encoding_tf;
  public final Memory encoding_nd;
  public final Memory fpu_cond;
  public final Memory c_cond_less;
  public final Memory c_cond_equal;
  public final Memory c_cond_unordered;
  public final Memory temp_fpu_byte_offset;
  public final Memory load_fpu_temp64;
  public final Memory address_load_fpu;
  public final Memory error_address_load_fpu;
  public final Memory todo_sys;
  public final Memory temp_jtlb_index;
  public final Memory temp_jtlb_entry_hi;
  public final Memory temp_jtlb_entry_lo0;
  public final Memory temp_jtlb_entry_lo1;
  public final Memory temp_jtlb_entry;
  public final Memory todo_nop;
  public final Memory todo_mmu;
  public final Memory temp_address;
  public final Memory temp_byte_offset;
  public final Memory temp_bit_offset;
  public final Memory temp_address_2_0;
  public final Memory load_temp64;
  public final Memory temp_address_load;
  public final Memory load_address_error;
  public final Memory store_address_error;
  public final Memory temp28;
  public final Memory todo_alu;
  public final Memory temp_reverse;
  public final Memory is_delay_slot;
  public final Memory last_branch_instruction;
  public final Memory jump_address;
  public final Memory temp_load_address;

  private TempVars() {
    this.tempCPR = Memory.def(Memory.Kind.VAR, "tempCPR", TypeDefs.DWORD, 1);
    this.tempCP2CPR = Memory.def(Memory.Kind.VAR, "tempCP2CPR", TypeDefs.DWORD, 1);
    this.hint = Memory.def(Memory.Kind.VAR, "hint", Type.CARD(5), 1);
    this.hint4b = Memory.def(Memory.Kind.VAR, "hint4b", Type.CARD(4), 1);
    this.temp_bit = Memory.def(Memory.Kind.VAR, "temp_bit", TypeDefs.BIT, 1);
    this.temp6 = Memory.def(Memory.Kind.VAR, "temp6", Type.CARD(6), 1);
    this.temp = Memory.def(Memory.Kind.VAR, "temp", TypeDefs.WORD, 1);
    this.temp0 = Memory.def(Memory.Kind.VAR, "temp0", TypeDefs.WORD, 1);
    this.temp1 = Memory.def(Memory.Kind.VAR, "temp1", TypeDefs.WORD, 1);
    this.temp2 = Memory.def(Memory.Kind.VAR, "temp2", TypeDefs.WORD, 1);
    this.temp3 = Memory.def(Memory.Kind.VAR, "temp3", TypeDefs.WORD, 1);
    this.tempI = Memory.def(Memory.Kind.VAR, "tempI", TypeDefs.INT, 1);
    this.temp64 = Memory.def(Memory.Kind.VAR, "temp64", TypeDefs.DWORD, 1);
    this.temp64_0 = Memory.def(Memory.Kind.VAR, "temp64_0", TypeDefs.DWORD, 1);
    this.temp64_1 = Memory.def(Memory.Kind.VAR, "temp64_1", TypeDefs.DWORD, 1);
    this.temp64_2 = Memory.def(Memory.Kind.VAR, "temp64_2", TypeDefs.DWORD, 1);
    this.temp64_3 = Memory.def(Memory.Kind.VAR, "temp64_3", TypeDefs.DWORD, 1);
    this.tempL = Memory.def(Memory.Kind.VAR, "tempL", TypeDefs.LONG, 1);
    this.temp_fp_s = Memory.def(Memory.Kind.VAR, "temp_fp_s", TypeDefs.FLOAT32, 1);
    this.temp_fp_s2 = Memory.def(Memory.Kind.VAR, "temp_fp_s2", TypeDefs.FLOAT32, 1);
    this.temp_fp_d = Memory.def(Memory.Kind.VAR, "temp_fp_d", TypeDefs.FLOAT64, 1);
    this.temp_fp_d2 = Memory.def(Memory.Kind.VAR, "temp_fp_d2", TypeDefs.FLOAT64, 1);
    this.temp128 = Memory.def(Memory.Kind.VAR, "temp128", TypeDefs.QWORD, 1);
    this.temp128_0 = Memory.def(Memory.Kind.VAR, "temp128_0", TypeDefs.QWORD, 1);
    this.temp128_1 = Memory.def(Memory.Kind.VAR, "temp128_1", TypeDefs.QWORD, 1);
    this.temp128_2 = Memory.def(Memory.Kind.VAR, "temp128_2", TypeDefs.QWORD, 1);
    this.temp33 = Memory.def(Memory.Kind.VAR, "temp33", Type.CARD(33), 1);
    this.temp65 = Memory.def(Memory.Kind.VAR, "temp65", Type.CARD(65), 1);
    this.op_encoding = Memory.def(Memory.Kind.VAR, "op_encoding", Type.CARD(6), 1);
    this.todo_fpu = Memory.def(Memory.Kind.VAR, "todo_fpu", TypeDefs.QWORD, 1);
    this.fmt_fpu = Memory.def(Memory.Kind.VAR, "fmt_fpu", Type.CARD(5), 1);
    this.fmt3_fpu = Memory.def(Memory.Kind.VAR, "fmt3_fpu", Type.CARD(3), 1);
    this.encoding_tf = Memory.def(Memory.Kind.VAR, "encoding_tf", TypeDefs.BIT, 1);
    this.encoding_nd = Memory.def(Memory.Kind.VAR, "encoding_nd", TypeDefs.BIT, 1);
    this.fpu_cond = Memory.def(Memory.Kind.VAR, "fpu_cond", Type.CARD(4), 1);
    this.c_cond_less = Memory.def(Memory.Kind.VAR, "c_cond_less", TypeDefs.BIT, 1);
    this.c_cond_equal = Memory.def(Memory.Kind.VAR, "c_cond_equal", TypeDefs.BIT, 1);
    this.c_cond_unordered = Memory.def(Memory.Kind.VAR, "c_cond_unordered", TypeDefs.BIT, 1);
    this.temp_fpu_byte_offset = Memory.def(Memory.Kind.VAR, "temp_fpu_byte_offset", Type.CARD(3), 1);
    this.load_fpu_temp64 = Memory.def(Memory.Kind.VAR, "load_fpu_temp64", TypeDefs.DWORD, 1);
    this.address_load_fpu = Memory.def(Memory.Kind.VAR, "address_load_fpu", TypeDefs.DWORD, 1);
    this.error_address_load_fpu = Memory.def(Memory.Kind.VAR, "error_address_load_fpu", TypeDefs.WORD, 1);
    this.todo_sys = Memory.def(Memory.Kind.VAR, "todo_sys", TypeDefs.QWORD, 1);
    this.temp_jtlb_index = Memory.def(Memory.Kind.VAR, "temp_jtlb_index", TypeDefs.DWORD, 1);
    this.temp_jtlb_entry_hi = Memory.def(Memory.Kind.VAR, "temp_jtlb_entry_hi", TypeDefs.DWORD, 1);
    this.temp_jtlb_entry_lo0 = Memory.def(Memory.Kind.VAR, "temp_jtlb_entry_lo0", TypeDefs.DWORD, 1);
    this.temp_jtlb_entry_lo1 = Memory.def(Memory.Kind.VAR, "temp_jtlb_entry_lo1", TypeDefs.DWORD, 1);
    this.temp_jtlb_entry = Memory.def(Memory.Kind.VAR, "temp_jtlb_entry", TypeDefs.JTLB_ENTRY, 1);
    this.todo_nop = Memory.def(Memory.Kind.VAR, "todo_nop", TypeDefs.QWORD, 1);
    this.todo_mmu = Memory.def(Memory.Kind.VAR, "todo_mmu", TypeDefs.QWORD, 1);
    this.temp_address = Memory.def(Memory.Kind.VAR, "temp_address", TypeDefs.DWORD, 1);
    this.temp_byte_offset = Memory.def(Memory.Kind.VAR, "temp_byte_offset", Type.CARD(3), 1);
    this.temp_bit_offset = Memory.def(Memory.Kind.VAR, "temp_bit_offset", Type.CARD(6), 1);
    this.temp_address_2_0 = Memory.def(Memory.Kind.VAR, "temp_address_2_0", Type.CARD(3), 1);
    this.load_temp64 = Memory.def(Memory.Kind.VAR, "load_temp64", TypeDefs.DWORD, 1);
    this.temp_address_load = Memory.def(Memory.Kind.VAR, "temp_address_load", TypeDefs.DWORD, 1);
    this.load_address_error = Memory.def(Memory.Kind.VAR, "load_address_error", TypeDefs.WORD, 1);
    this.store_address_error = Memory.def(Memory.Kind.VAR, "store_address_error", TypeDefs.WORD, 1);
    this.temp28 = Memory.def(Memory.Kind.VAR, "temp28", Type.CARD(28), 1);
    this.todo_alu = Memory.def(Memory.Kind.VAR, "todo_alu", TypeDefs.QWORD, 1);
    this.temp_reverse = Memory.def(Memory.Kind.VAR, "temp_reverse", TypeDefs.BYTE, 1);
    this.is_delay_slot = Memory.def(Memory.Kind.VAR, "is_delay_slot", TypeDefs.BIT, 1);
    this.last_branch_instruction = Memory.def(Memory.Kind.VAR, "last_branch_instruction", TypeDefs.BIT, 1);
    this.jump_address = Memory.def(Memory.Kind.VAR, "jump_address", TypeDefs.DWORD, 1);
    this.temp_load_address = Memory.def(Memory.Kind.VAR, "temp_load_address", TypeDefs.DWORD, 1);

    addVariable(tempCPR);
    addVariable(tempCP2CPR);
    addVariable(hint);
    addVariable(hint4b);
    addVariable(temp_bit);
    addVariable(temp6);
    addVariable(temp);
    addVariable(temp0);
    addVariable(temp1);
    addVariable(temp2);
    addVariable(temp3);
    addVariable(tempI);
    addVariable(temp64);
    addVariable(temp64_0);
    addVariable(temp64_1);
    addVariable(temp64_2);
    addVariable(temp64_3);
    addVariable(tempL);
    addVariable(temp_fp_s);
    addVariable(temp_fp_s2);
    addVariable(temp_fp_d);
    addVariable(temp_fp_d2);
    addVariable(temp128);
    addVariable(temp128_0);
    addVariable(temp128_1);
    addVariable(temp128_2);
    addVariable(temp33);
    addVariable(temp65);
    addVariable(op_encoding);
    addVariable(todo_fpu);
    addVariable(fmt_fpu);
    addVariable(fmt3_fpu);
    addVariable(encoding_tf);
    addVariable(encoding_nd);
    addVariable(fpu_cond);
    addVariable(c_cond_less);
    addVariable(c_cond_equal);
    addVariable(c_cond_unordered);
    addVariable(temp_fpu_byte_offset);
    addVariable(load_fpu_temp64);
    addVariable(address_load_fpu);
    addVariable(error_address_load_fpu);
    addVariable(todo_sys);
    addVariable(temp_jtlb_index);
    addVariable(temp_jtlb_entry_hi);
    addVariable(temp_jtlb_entry_lo0);
    addVariable(temp_jtlb_entry_lo1);
    addVariable(temp_jtlb_entry);
    addVariable(todo_nop);
    addVariable(todo_mmu);
    addVariable(temp_address);
    addVariable(temp_byte_offset);
    addVariable(temp_bit_offset);
    addVariable(temp_address_2_0);
    addVariable(load_temp64);
    addVariable(temp_address_load);
    addVariable(load_address_error);
    addVariable(store_address_error);
    addVariable(temp28);
    addVariable(todo_alu);
    addVariable(temp_reverse);
    addVariable(is_delay_slot);
    addVariable(last_branch_instruction);
    addVariable(jump_address);
    addVariable(temp_load_address);
  }

  private static final class TempVarsFactory implements Factory {
    @Override
    public TempVars create() {
      return new TempVars();
    }
  }

  public static Factory newFactory() {
    return new TempVarsFactory();
  }
}
