/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.op.bc1t;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.IsaPrimitive;

/**
 * The {@code DecoderBc1t} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderBc1t extends DecoderItem {
  private static DecoderBc1t instance = null;

  public static DecoderBc1t get() {
    if (null == instance) {
      instance = new DecoderBc1t();
    }
    return instance;
  }

  private DecoderBc1t() {
    super(
        32,
        true,
        "01000101000000010000000000000000",
        "11111111111000110000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    Immediate cc = null;
    IsaPrimitive offset = null;

    if (!matchNextOpc(image, BitVector.valueOf("01000101000", 2, 11))) {
      return null;
    }
    cc = readNextImmediate(image, Type.CARD(3));
    if (!matchNextOpc(image, BitVector.valueOf("0", 2, 1))) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("1", 2, 1))) {
      return null;
    }
    offset = (IsaPrimitive) readNextPrimitive(image, DecoderBRANCH_FPU_OFFSET.get());
    if (null == offset) {
      return null;
    }

    return newResult(new bc1t(cc, offset));
  }
}
