/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.op.dmfc0;
import ru.ispras.microtesk.model.mips64.mode.R;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderDmfc0} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderDmfc0 extends DecoderItem {
  private static DecoderDmfc0 instance = null;

  public static DecoderDmfc0 get() {
    if (null == instance) {
      instance = new DecoderDmfc0();
    }
    return instance;
  }

  private DecoderDmfc0() {
    super(
        32,
        true,
        "01000000001000000000000000000000",
        "11111111111000000000011111111000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R rt = null;
    Immediate rd = null;
    Immediate sel = null;

    if (!matchNextOpc(image, BitVector.valueOf("01000000001", 2, 11))) {
      return null;
    }
    rt = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rt) {
      return null;
    }
    rd = readNextImmediate(image, Type.CARD(5));
    if (!matchNextOpc(image, BitVector.valueOf("00000000", 2, 8))) {
      return null;
    }
    sel = readNextImmediate(image, Type.CARD(3));

    return newResult(new dmfc0(rt, rd, sel));
  }
}
