/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.FMT3_FORMAT_PS;

/**
 * The {@code DecoderFMT3_FORMAT_PS} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderFMT3_FORMAT_PS extends DecoderItem {
  private static DecoderFMT3_FORMAT_PS instance = null;

  public static DecoderFMT3_FORMAT_PS get() {
    if (null == instance) {
      instance = new DecoderFMT3_FORMAT_PS();
    }
    return instance;
  }

  private DecoderFMT3_FORMAT_PS() {
    super(
        3,
        true,
        "110",
        "111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    if (!matchNextOpc(image, BitVector.valueOf("110", 2, 3))) {
      return null;
    }

    return newResult(new FMT3_FORMAT_PS());
  }
}
