/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.op.jalr_hb2;
import ru.ispras.microtesk.model.mips64.mode.R;

/**
 * The {@code DecoderJalr_hb2} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderJalr_hb2 extends DecoderItem {
  private static DecoderJalr_hb2 instance = null;

  public static DecoderJalr_hb2 get() {
    if (null == instance) {
      instance = new DecoderJalr_hb2();
    }
    return instance;
  }

  private DecoderJalr_hb2() {
    super(
        32,
        true,
        "00000000000000000000010000001001",
        "11111100000111110000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R rd = null;
    R rs = null;

    if (!matchNextOpc(image, BitVector.valueOf("000000", 2, 6))) {
      return null;
    }
    rs = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rs) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("00000", 2, 5))) {
      return null;
    }
    rd = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("1", 2, 1))) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("0000", 2, 4))) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("001001", 2, 6))) {
      return null;
    }

    return newResult(new jalr_hb2(rd, rs));
  }
}
