/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.op.jalx;
import ru.ispras.microtesk.model.IsaPrimitive;

/**
 * The {@code DecoderJalx} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderJalx extends DecoderItem {
  private static DecoderJalx instance = null;

  public static DecoderJalx get() {
    if (null == instance) {
      instance = new DecoderJalx();
    }
    return instance;
  }

  private DecoderJalx() {
    super(
        32,
        true,
        "01110100000000000000000000000000",
        "11111100000000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    IsaPrimitive instr_index = null;

    if (!matchNextOpc(image, BitVector.valueOf("011101", 2, 6))) {
      return null;
    }
    instr_index = (IsaPrimitive) readNextPrimitive(image, DecoderJUMP_ADDR.get());
    if (null == instr_index) {
      return null;
    }

    return newResult(new jalx(instr_index));
  }
}
