/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.op.ldxc1;
import ru.ispras.microtesk.model.mips64.mode.FR;
import ru.ispras.microtesk.model.mips64.mode.R;

/**
 * The {@code DecoderLdxc1} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderLdxc1 extends DecoderItem {
  private static DecoderLdxc1 instance = null;

  public static DecoderLdxc1 get() {
    if (null == instance) {
      instance = new DecoderLdxc1();
    }
    return instance;
  }

  private DecoderLdxc1() {
    super(
        32,
        true,
        "11010100000000000000000000000001",
        "11111100000000001111100000111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    FR fd = null;
    R index = null;
    R base = null;

    if (!matchNextOpc(image, BitVector.valueOf("110101", 2, 6))) {
      return null;
    }
    base = (R) readNextPrimitive(image, DecoderR.get());
    if (null == base) {
      return null;
    }
    index = (R) readNextPrimitive(image, DecoderR.get());
    if (null == index) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("00000", 2, 5))) {
      return null;
    }
    fd = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == fd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("000001", 2, 6))) {
      return null;
    }

    return newResult(new ldxc1(fd, index, base));
  }
}
