/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.op.movz_fmt;
import ru.ispras.microtesk.model.IsaPrimitive;
import ru.ispras.microtesk.model.mips64.mode.FR;
import ru.ispras.microtesk.model.mips64.mode.R;

/**
 * The {@code DecoderMovz_fmt} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderMovz_fmt extends DecoderItem {
  private static DecoderMovz_fmt instance = null;

  public static DecoderMovz_fmt get() {
    if (null == instance) {
      instance = new DecoderMovz_fmt();
    }
    return instance;
  }

  private DecoderMovz_fmt() {
    super(
        32,
        true,
        "01000100000000000000000000010010",
        "11111100000000000000000000111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    IsaPrimitive op_fmt = null;
    FR fd = null;
    FR fs = null;
    R rt = null;

    if (!matchNextOpc(image, BitVector.valueOf("010001", 2, 6))) {
      return null;
    }
    op_fmt = (IsaPrimitive) readNextPrimitive(image, DecoderFMT_FORMAT.get());
    if (null == op_fmt) {
      return null;
    }
    rt = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rt) {
      return null;
    }
    fs = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == fs) {
      return null;
    }
    fd = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == fd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("010010", 2, 6))) {
      return null;
    }

    return newResult(new movz_fmt(op_fmt, fd, fs, rt));
  }
}
