/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.op.mtc0;
import ru.ispras.microtesk.model.mips64.mode.R;
import ru.ispras.microtesk.model.mips64.mode.C0_R;

/**
 * The {@code DecoderMtc0} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderMtc0 extends DecoderItem {
  private static DecoderMtc0 instance = null;

  public static DecoderMtc0 get() {
    if (null == instance) {
      instance = new DecoderMtc0();
    }
    return instance;
  }

  private DecoderMtc0() {
    super(
        32,
        true,
        "01000000100000000000000000000000",
        "11111111111000000000011111111000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R rt = null;
    C0_R rd = null;

    if (!matchNextOpc(image, BitVector.valueOf("01000000100", 2, 11))) {
      return null;
    }
    rt = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rt) {
      return null;
    }
    rd = (C0_R) readNextPrimitive(image, DecoderC0_R.get());
    if (null == rd) {
      return null;
    }

    return newResult(new mtc0(rt, rd));
  }
}
