/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.NGLE_COND;

/**
 * The {@code DecoderNGLE_COND} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderNGLE_COND extends DecoderItem {
  private static DecoderNGLE_COND instance = null;

  public static DecoderNGLE_COND get() {
    if (null == instance) {
      instance = new DecoderNGLE_COND();
    }
    return instance;
  }

  private DecoderNGLE_COND() {
    super(
        4,
        true,
        "1001",
        "1111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    if (!matchNextOpc(image, BitVector.valueOf("1001", 2, 4))) {
      return null;
    }

    return newResult(new NGLE_COND());
  }
}
