/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.op.puups_s;
import ru.ispras.microtesk.model.mips64.mode.FR;

/**
 * The {@code DecoderPuups_s} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderPuups_s extends DecoderItem {
  private static DecoderPuups_s instance = null;

  public static DecoderPuups_s get() {
    if (null == instance) {
      instance = new DecoderPuups_s();
    }
    return instance;
  }

  private DecoderPuups_s() {
    super(
        32,
        true,
        "01000110110000000000000000101111",
        "11111111111000000000000000111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    FR fd = null;
    FR fs = null;
    FR ft = null;

    if (!matchNextOpc(image, BitVector.valueOf("01000110110", 2, 11))) {
      return null;
    }
    ft = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == ft) {
      return null;
    }
    fs = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == fs) {
      return null;
    }
    fd = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == fd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("101111", 2, 6))) {
      return null;
    }

    return newResult(new puups_s(fd, fs, ft));
  }
}
