/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.op.sc;
import ru.ispras.microtesk.model.mips64.mode.R;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderSc} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSc extends DecoderItem {
  private static DecoderSc instance = null;

  public static DecoderSc get() {
    if (null == instance) {
      instance = new DecoderSc();
    }
    return instance;
  }

  private DecoderSc() {
    super(
        32,
        true,
        "11100000000000000000000000000000",
        "11111100000000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R rt = null;
    Immediate offset = null;
    R base = null;

    if (!matchNextOpc(image, BitVector.valueOf("111000", 2, 6))) {
      return null;
    }
    base = (R) readNextPrimitive(image, DecoderR.get());
    if (null == base) {
      return null;
    }
    rt = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rt) {
      return null;
    }
    offset = readNextImmediate(image, SHORT);

    return newResult(new sc(rt, offset, base));
  }
}
