/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.op.sdbbp;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderSdbbp} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSdbbp extends DecoderItem {
  private static DecoderSdbbp instance = null;

  public static DecoderSdbbp get() {
    if (null == instance) {
      instance = new DecoderSdbbp();
    }
    return instance;
  }

  private DecoderSdbbp() {
    super(
        32,
        true,
        "00000000000000000000000000001110",
        "11111100000000000000000000111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    Immediate code_sdbbp = null;

    if (!matchNextOpc(image, BitVector.valueOf("000000", 2, 6))) {
      return null;
    }
    code_sdbbp = readNextImmediate(image, Type.CARD(20));
    if (!matchNextOpc(image, BitVector.valueOf("001110", 2, 6))) {
      return null;
    }

    return newResult(new sdbbp(code_sdbbp));
  }
}
