/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.op.synci;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.mips64.mode.R;

/**
 * The {@code DecoderSynci} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderSynci extends DecoderItem {
  private static DecoderSynci instance = null;

  public static DecoderSynci get() {
    if (null == instance) {
      instance = new DecoderSynci();
    }
    return instance;
  }

  private DecoderSynci() {
    super(
        32,
        true,
        "00000100000111110000000000000000",
        "11111100000111110000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    Immediate offset = null;
    R base = null;

    if (!matchNextOpc(image, BitVector.valueOf("000001", 2, 6))) {
      return null;
    }
    base = (R) readNextPrimitive(image, DecoderR.get());
    if (null == base) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("11111", 2, 5))) {
      return null;
    }
    offset = readNextImmediate(image, SHORT);

    return newResult(new synci(offset, base));
  }
}
