/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.metadata;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import java.math.BigInteger;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.metadata.MetaModel;
import ru.ispras.microtesk.model.metadata.MetaModelBuilder;

/**
 * The {@code MetaModelFactory} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MetaModelFactory {
  private MetaModelFactory() {}

  public static MetaModel newMetaModel() {
    final MetaModelBuilder builder = new MetaModelBuilder();

    builder.addRegister("CIA", DWORD, 1);
    builder.addRegister("CIA_BRANCH", DWORD, 1);
    builder.addRegister("JTLB", JTLB_ENTRY, 64);
    builder.addRegister("GPR", DWORD, 32);
    builder.addRegister("HI", DWORD, 1);
    builder.addRegister("LO", DWORD, 1);
    builder.addRegister("FPR", DWORD, 32);
    builder.addRegister("CPR", DWORD, 256);
    builder.addRegister("C0_INDEX", DWORD, 1);
    builder.addRegister("C0_RANDOM", DWORD, 1);
    builder.addRegister("C0_ENTRY_LO0", DWORD, 1);
    builder.addRegister("C0_ENTRY_LO1", DWORD, 1);
    builder.addRegister("C0_CONTEXT", DWORD, 1);
    builder.addRegister("C0_PAGE_MASK", DWORD, 1);
    builder.addRegister("C0_WIRED", DWORD, 1);
    builder.addRegister("C0_BAD_VADDR", DWORD, 1);
    builder.addRegister("C0_COUNT", DWORD, 1);
    builder.addRegister("C0_ENTRY_HI", DWORD, 1);
    builder.addRegister("C0_COMPARE", DWORD, 1);
    builder.addRegister("C0_STATUS", DWORD, 1);
    builder.addRegister("C0_INTCTL", DWORD, 1);
    builder.addRegister("C0_SRSCTL", DWORD, 1);
    builder.addRegister("C0_CAUSE", DWORD, 1);
    builder.addRegister("C0_EPC", DWORD, 1);
    builder.addRegister("C0_PROCESSOR_ID", DWORD, 1);
    builder.addRegister("C0_CONFIG0", DWORD, 1);
    builder.addRegister("C0_CONFIG0_K0", Type.CARD(3), 1);
    builder.addRegister("C0_CONFIG1", DWORD, 1);
    builder.addRegister("C0_CONFIG2", DWORD, 1);
    builder.addRegister("C0_CONFIG3", DWORD, 1);
    builder.addRegister("C0_LOAD_LINKED_ADDRESS", DWORD, 1);
    builder.addRegister("C0_WATCH_LO", DWORD, 1);
    builder.addRegister("C0_WATCH_HI", DWORD, 1);
    builder.addRegister("C0_XCONTEXT", DWORD, 1);
    builder.addRegister("C0_DEBUG", DWORD, 1);
    builder.addRegister("C0_DEBUG_EPC", DWORD, 1);
    builder.addRegister("C0_PERFORMANCE_COUNTER", DWORD, 1);
    builder.addRegister("C0_ERR_CTRL", DWORD, 1);
    builder.addRegister("C0_CACHE_ERR", DWORD, 1);
    builder.addRegister("C0_TAG_DATA_LO", DWORD, 1);
    builder.addRegister("C0_TAG_DATA_HI", DWORD, 1);
    builder.addRegister("C0_ERROR_EPC", DWORD, 1);
    builder.addRegister("C0_DESAVE", DWORD, 1);
    builder.addRegister("C0_STATUS_CU3", BIT, 1);
    builder.addRegister("C0_STATUS_CU2", BIT, 1);
    builder.addRegister("C0_STATUS_CU1", BIT, 1);
    builder.addRegister("C0_STATUS_CU0", BIT, 1);
    builder.addRegister("C0_STATUS_RE", BIT, 1);
    builder.addRegister("C0_STATUS_BEV", BIT, 1);
    builder.addRegister("C0_STATUS_UX", BIT, 1);
    builder.addRegister("C0_STATUS_KSU", Type.CARD(2), 1);
    builder.addRegister("C0_STATUS_UM", BIT, 1);
    builder.addRegister("C0_STATUS_R0", BIT, 1);
    builder.addRegister("C0_STATUS_ERL", BIT, 1);
    builder.addRegister("C0_STATUS_EXL", BIT, 1);
    builder.addRegister("C0_STATUS_IE", BIT, 1);
    builder.addRegister("C0_SRSCTL_HSS", Type.CARD(4), 1);
    builder.addRegister("C0_SRSCTL_PSS", Type.CARD(4), 1);
    builder.addRegister("C0_SRSCTL_CSS", Type.CARD(4), 1);
    builder.addRegister("C0_CONFIG1_M", BIT, 1);
    builder.addRegister("C0_CONFIG1_MMUSize", Type.CARD(6), 1);
    builder.addRegister("C0_CONFIG1_IS", Type.CARD(3), 1);
    builder.addRegister("C0_CONFIG1_IL", Type.CARD(3), 1);
    builder.addRegister("C0_CONFIG1_IA", Type.CARD(3), 1);
    builder.addRegister("C0_CONFIG1_DS", Type.CARD(3), 1);
    builder.addRegister("C0_CONFIG1_DL", Type.CARD(3), 1);
    builder.addRegister("C0_CONFIG1_DA", Type.CARD(3), 1);
    builder.addRegister("C0_CONFIG1_C2", BIT, 1);
    builder.addRegister("C0_CONFIG1_MD", BIT, 1);
    builder.addRegister("C0_CONFIG1_PC", BIT, 1);
    builder.addRegister("C0_CONFIG1_WR", BIT, 1);
    builder.addRegister("C0_CONFIG1_CA", BIT, 1);
    builder.addRegister("C0_CONFIG1_EP", BIT, 1);
    builder.addRegister("C0_CONFIG1_FP", BIT, 1);
    builder.addRegister("C0_CONFIG3_M", BIT, 1);
    builder.addRegister("C0_CONFIG3_SM", BIT, 1);
    builder.addRegister("C0_CONFIG3_TL", BIT, 1);
    builder.addRegister("C0_CONFIG3_ISA", Type.CARD(2), 1);
    builder.addRegister("C0_DEBUG_DBD", BIT, 1);
    builder.addRegister("C0_DEBUG_DM", BIT, 1);
    builder.addRegister("C0_DEBUG_NoDCR", BIT, 1);
    builder.addRegister("C0_DEBUG_IEXI", BIT, 1);
    builder.addRegister("C0_DEBUG_EJTAGver", Type.CARD(3), 1);
    builder.addRegister("C0_DEBUG_DSS", BIT, 1);
    builder.addRegister("CP2CPR", DWORD, 256);
    builder.addRegister("FCR", WORD, 32);
    builder.addRegister("FIR", WORD, 1);
    builder.addRegister("FCCR", WORD, 1);
    builder.addRegister("FEXR", WORD, 1);
    builder.addRegister("FENR", WORD, 1);
    builder.addRegister("FCSR", WORD, 1);
    builder.addRegister("FCSR_FCC_1_7", Type.CARD(7), 1);
    builder.addRegister("FCSR_FS", BIT, 1);
    builder.addRegister("FCSR_FCC_0", BIT, 1);
    builder.addRegister("FCSR_Impl", Type.CARD(2), 1);
    builder.addRegister("FCSR_Cause", Type.CARD(6), 1);
    builder.addRegister("FCSR_Enables", Type.CARD(5), 1);
    builder.addRegister("FCSR_Flags", Type.CARD(5), 1);
    builder.addRegister("FCSR_RM", Type.CARD(2), 1);
    builder.addRegister("VPR", QWORD, 32);
    builder.addRegister("LLbit", BIT, 1);
    builder.addRegister("ISAMode", BIT, 1);
    builder.addRegister("FPConditionCode_value", BIT, 1);

    builder.addMemory("BRANCH", BIT, 0x1);
    builder.addMemory("BRANCH_INSTRUCTION", BIT, 0x1);
    builder.addMemory("SKIPOP", BIT, 0x1);
    builder.addMemory("NEXTPC", DWORD, 0x1);
    builder.addMemory("MEM", DWORD, 0x200000000L);
    builder.addMemory("COMPACT_BRANCH", BIT, 0x1);

    builder.addMode(ZERO.get());
    builder.addMode(AT.get());
    builder.addMode(VREG.get());
    builder.addMode(AREG.get());
    builder.addMode(TREG.get());
    builder.addMode(SREG.get());
    builder.addMode(KREG.get());
    builder.addMode(GP.get());
    builder.addMode(SP.get());
    builder.addMode(FP.get());
    builder.addMode(RA.get());
    builder.addMode(R.get());
    builder.addMode(FR.get());
    builder.addMode(CPRGET.get());
    builder.addMode(CPRSET.get());
    builder.addMode(C0_R.get());
    builder.addMode(CP2CPRGET.get());
    builder.addMode(CP2CPRSET.get());
    builder.addMode(C.get());
    builder.addMode(FMT_FORMAT_S.get());
    builder.addMode(FMT_FORMAT_D.get());
    builder.addMode(FMT_FORMAT_W.get());
    builder.addMode(FMT_FORMAT_L.get());
    builder.addMode(FMT_FORMAT_PS.get());
    builder.addMode(FMT_FORMAT.get());
    builder.addMode(FMT_FORMAT_ALL.get());
    builder.addMode(FMT_FORMAT_D_W_L.get());
    builder.addMode(FMT3_FORMAT_S.get());
    builder.addMode(FMT3_FORMAT_D.get());
    builder.addMode(FMT3_FORMAT_PS.get());
    builder.addMode(FMT3_FORMAT.get());
    builder.addMode(F_COND.get());
    builder.addMode(UN_COND.get());
    builder.addMode(EQ_COND.get());
    builder.addMode(UEQ_COND.get());
    builder.addMode(OLT_COND.get());
    builder.addMode(ULT_COND.get());
    builder.addMode(OLE_COND.get());
    builder.addMode(ULE_COND.get());
    builder.addMode(SF_COND.get());
    builder.addMode(NGLE_COND.get());
    builder.addMode(SEQ_COND.get());
    builder.addMode(NGL_COND.get());
    builder.addMode(LT_COND.get());
    builder.addMode(NGE_COND.get());
    builder.addMode(LE_COND.get());
    builder.addMode(NGT_COND.get());
    builder.addMode(FPU_COND_TYPE.get());
    builder.addMode(BRANCH_FPU_LABEL.get());
    builder.addMode(BRANCH_FPU_IMM.get());
    builder.addMode(BRANCH_FPU_OFFSET.get());
    builder.addMode(BRANCH_LABEL.get());
    builder.addMode(BRANCH_IMM.get());
    builder.addMode(BRANCH_OFFSET.get());
    builder.addMode(BRANCH_LABEL21.get());
    builder.addMode(BRANCH_IMM21.get());
    builder.addMode(BRANCH_OFFSET21.get());
    builder.addMode(BRANCH_LABEL26.get());
    builder.addMode(BRANCH_IMM26.get());
    builder.addMode(BRANCH_OFFSET26.get());
    builder.addMode(JUMP_LABEL.get());
    builder.addMode(JUMP_IMM.get());
    builder.addMode(JUMP_ADDR.get());
    builder.addMode(JUMP_LABEL16.get());
    builder.addMode(JUMP_IMM16.get());
    builder.addMode(JUMP_ADDR16.get());
    builder.addMode(LOAD_LABEL.get());
    builder.addMode(LOAD_IMM.get());
    builder.addMode(LOAD_ADDR.get());

    builder.addOperation(NullifyCurrentInstruction.get());
    builder.addOperation(add_exception.get());
    builder.addOperation(StoreFPR.get());
    builder.addOperation(add_fmt.get());
    builder.addOperation(abs_fmt.get());
    builder.addOperation(div_fmt.get());
    builder.addOperation(madd_fmt.get());
    builder.addOperation(msub_fmt.get());
    builder.addOperation(mul_fmt.get());
    builder.addOperation(neg_fmt.get());
    builder.addOperation(nmadd_fmt.get());
    builder.addOperation(nmsub_fmt.get());
    builder.addOperation(recip_fmt.get());
    builder.addOperation(rsqrt_fmt.get());
    builder.addOperation(sqrt_fmt.get());
    builder.addOperation(sub_fmt.get());
    builder.addOperation(MIPS64FpuArithmeticRR.get());
    builder.addOperation(MIPS64FpuArithmeticRRR.get());
    builder.addOperation(MIPS64FpuArithmeticRRRR.get());
    builder.addOperation(MIPS64FpuArithmetic.get());
    builder.addOperation(C_cond.get());
    builder.addOperation(C_cond2.get());
    builder.addOperation(FPConditionCode.get());
    builder.addOperation(bc1f.get());
    builder.addOperation(bc1f2.get());
    builder.addOperation(bc1fl.get());
    builder.addOperation(bc1fl2.get());
    builder.addOperation(bc1t.get());
    builder.addOperation(bc1t2.get());
    builder.addOperation(bc1tl.get());
    builder.addOperation(bc1tl2.get());
    builder.addOperation(MIPS32FpuBranchOp.get());
    builder.addOperation(MIPS32FpuBranchCond.get());
    builder.addOperation(MIPS32FpuBranch.get());
    builder.addOperation(mips64_load_fpu.get());
    builder.addOperation(mips64_load_fpu_short.get());
    builder.addOperation(ldc1.get());
    builder.addOperation(ldxc1.get());
    builder.addOperation(MIPS64FpuMEM.get());
    builder.addOperation(cfc1.get());
    builder.addOperation(ctc1.get());
    builder.addOperation(dmfc1.get());
    builder.addOperation(dmtc1.get());
    builder.addOperation(mfc1.get());
    builder.addOperation(mtc1.get());
    builder.addOperation(mfhc1.get());
    builder.addOperation(mthc1.get());
    builder.addOperation(mov_fmt.get());
    builder.addOperation(movf.get());
    builder.addOperation(movf_fmt.get());
    builder.addOperation(movn_fmt.get());
    builder.addOperation(movt.get());
    builder.addOperation(movt_fmt.get());
    builder.addOperation(movz_fmt.get());
    builder.addOperation(MIPS32FpuMove.get());
    builder.addOperation(MIPS64FpuMove.get());
    builder.addOperation(cvtd_fmt.get());
    builder.addOperation(cvtl_fmt.get());
    builder.addOperation(cvtps_s.get());
    builder.addOperation(cvts_pl.get());
    builder.addOperation(cvts_pu.get());
    builder.addOperation(cvts_fmt.get());
    builder.addOperation(cvtw_fmt.get());
    builder.addOperation(ceill_fmt.get());
    builder.addOperation(ceilw_fmt.get());
    builder.addOperation(alnvps_fmt.get());
    builder.addOperation(floorl_fmt.get());
    builder.addOperation(floorw_fmt.get());
    builder.addOperation(pllps_s.get());
    builder.addOperation(plups_s.get());
    builder.addOperation(pulps_s.get());
    builder.addOperation(puups_s.get());
    builder.addOperation(roundl_fmt.get());
    builder.addOperation(roundw_fmt.get());
    builder.addOperation(truncl_fmt.get());
    builder.addOperation(truncw_fmt.get());
    builder.addOperation(MIPS64FpuConvert.get());
    builder.addOperation(MIPS64FpuOp.get());
    builder.addOperation(cache.get());
    builder.addOperation(mfhi.get());
    builder.addOperation(mflo.get());
    builder.addOperation(mthi.get());
    builder.addOperation(mtlo.get());
    builder.addOperation(tlbwi.get());
    builder.addOperation(tlbwr.get());
    builder.addOperation(wait.get());
    builder.addOperation(ehb.get());
    builder.addOperation(break_ins.get());
    builder.addOperation(syscall.get());
    builder.addOperation(teq.get());
    builder.addOperation(teqi.get());
    builder.addOperation(tge.get());
    builder.addOperation(tgei.get());
    builder.addOperation(tgeiu.get());
    builder.addOperation(tgeu.get());
    builder.addOperation(tlt.get());
    builder.addOperation(tlti.get());
    builder.addOperation(tltiu.get());
    builder.addOperation(tltu.get());
    builder.addOperation(tne.get());
    builder.addOperation(tnei.get());
    builder.addOperation(MipsSysTrapOp.get());
    builder.addOperation(deret.get());
    builder.addOperation(sdbbp.get());
    builder.addOperation(MipsSysDebugOp.get());
    builder.addOperation(di.get());
    builder.addOperation(di2.get());
    builder.addOperation(ei.get());
    builder.addOperation(ei2.get());
    builder.addOperation(eret.get());
    builder.addOperation(dmfc0.get());
    builder.addOperation(dmfc0_2.get());
    builder.addOperation(dmtc0.get());
    builder.addOperation(dmtc0_2.get());
    builder.addOperation(mfc0.get());
    builder.addOperation(mfc0_2.get());
    builder.addOperation(mfc0_3.get());
    builder.addOperation(mtc0.get());
    builder.addOperation(mtc0_2.get());
    builder.addOperation(mtc0_3.get());
    builder.addOperation(tlbp.get());
    builder.addOperation(tlbr.get());
    builder.addOperation(MipsSysC0Op.get());
    builder.addOperation(dmfc2.get());
    builder.addOperation(dmfc22.get());
    builder.addOperation(dmtc2.get());
    builder.addOperation(dmtc22.get());
    builder.addOperation(mfc2.get());
    builder.addOperation(mfc22.get());
    builder.addOperation(mtc2.get());
    builder.addOperation(mtc22.get());
    builder.addOperation(MipsSysC2Op.get());
    builder.addOperation(ldc2.get());
    builder.addOperation(lwc2.get());
    builder.addOperation(MipsSysLSOp.get());
    builder.addOperation(MipsSysOp.get());
    builder.addOperation(MIPS64SysOp.get());
    builder.addOperation(nop.get());
    builder.addOperation(ssnop.get());
    builder.addOperation(MipsNopOp.get());
    builder.addOperation(MIPS64NopOp.get());
    builder.addOperation(lb.get());
    builder.addOperation(lbu.get());
    builder.addOperation(sb.get());
    builder.addOperation(ld.get());
    builder.addOperation(sd.get());
    builder.addOperation(lh.get());
    builder.addOperation(lhu.get());
    builder.addOperation(sh.get());
    builder.addOperation(lw.get());
    builder.addOperation(lwu.get());
    builder.addOperation(sw.get());
    builder.addOperation(ll.get());
    builder.addOperation(ldl.get());
    builder.addOperation(ldr.get());
    builder.addOperation(lwl.get());
    builder.addOperation(lwr.get());
    builder.addOperation(lld.get());
    builder.addOperation(pref.get());
    builder.addOperation(sc.get());
    builder.addOperation(scd.get());
    builder.addOperation(sdl.get());
    builder.addOperation(sdr.get());
    builder.addOperation(swl.get());
    builder.addOperation(swr.get());
    builder.addOperation(sync.get());
    builder.addOperation(sync0.get());
    builder.addOperation(synci.get());
    builder.addOperation(MipsMmuOp.get());
    builder.addOperation(MipsMmuOp32.get());
    builder.addOperation(MipsMmuOp64.get());
    builder.addOperation(MIPS64MmuOp.get());
    builder.addOperation(b.get());
    builder.addOperation(beq.get());
    builder.addOperation(beql.get());
    builder.addOperation(bgez.get());
    builder.addOperation(bgezal.get());
    builder.addOperation(bgezall.get());
    builder.addOperation(beqzc.get());
    builder.addOperation(bnezc.get());
    builder.addOperation(bgezl.get());
    builder.addOperation(bgtz.get());
    builder.addOperation(bgtzl.get());
    builder.addOperation(blez.get());
    builder.addOperation(blezl.get());
    builder.addOperation(bltz.get());
    builder.addOperation(bltzal.get());
    builder.addOperation(bltzall.get());
    builder.addOperation(bltzl.get());
    builder.addOperation(bne.get());
    builder.addOperation(bnel.get());
    builder.addOperation(j.get());
    builder.addOperation(jal.get());
    builder.addOperation(jalr2.get());
    builder.addOperation(jalr.get());
    builder.addOperation(jalr_hb2.get());
    builder.addOperation(jalr_hb.get());
    builder.addOperation(jalx.get());
    builder.addOperation(jr.get());
    builder.addOperation(jr_hb.get());
    builder.addOperation(MIPSBpuI.get());
    builder.addOperation(MIPSBpuR.get());
    builder.addOperation(MIPSBpuRR.get());
    builder.addOperation(MIPSBpuRI.get());
    builder.addOperation(MIPSBpuRRI.get());
    builder.addOperation(MipsFXUBranch.get());
    builder.addOperation(MipsBpuOp.get());
    builder.addOperation(MIPS64BpuOp.get());
    builder.addOperation(check_sign_extend_value.get());
    builder.addOperation(check_sign_extend_values.get());
    builder.addOperation(add.get());
    builder.addOperation(addi.get());
    builder.addOperation(addiu.get());
    builder.addOperation(addu.get());
    builder.addOperation(clo.get());
    builder.addOperation(clz.get());
    builder.addOperation(div.get());
    builder.addOperation(divu.get());
    builder.addOperation(madd.get());
    builder.addOperation(maddu.get());
    builder.addOperation(msub.get());
    builder.addOperation(msubu.get());
    builder.addOperation(mul.get());
    builder.addOperation(mult.get());
    builder.addOperation(multu.get());
    builder.addOperation(sub.get());
    builder.addOperation(subu.get());
    builder.addOperation(Mips32ArithmeticRR.get());
    builder.addOperation(Mips32ArithmeticRRR.get());
    builder.addOperation(Mips32ArithmeticRRI.get());
    builder.addOperation(Mips32ArithmeticOp.get());
    builder.addOperation(slt.get());
    builder.addOperation(slti.get());
    builder.addOperation(sltiu.get());
    builder.addOperation(sltu.get());
    builder.addOperation(movn.get());
    builder.addOperation(movz.get());
    builder.addOperation(Mips32ConditionTestingRRR.get());
    builder.addOperation(Mips32ConditionTestingRRI.get());
    builder.addOperation(Mips32ConditionTestingOp.get());
    builder.addOperation(and.get());
    builder.addOperation(andi.get());
    builder.addOperation(nor.get());
    builder.addOperation(or.get());
    builder.addOperation(ori.get());
    builder.addOperation(xor.get());
    builder.addOperation(xori.get());
    builder.addOperation(Mips32LogicalRRR.get());
    builder.addOperation(Mips32LogicalRRI.get());
    builder.addOperation(Mips32LogicalOp.get());
    builder.addOperation(rotr.get());
    builder.addOperation(rotrv.get());
    builder.addOperation(sll.get());
    builder.addOperation(sllv.get());
    builder.addOperation(sra.get());
    builder.addOperation(srav.get());
    builder.addOperation(srl.get());
    builder.addOperation(srlv.get());
    builder.addOperation(Mips32ShiftRRI.get());
    builder.addOperation(Mips32ShiftRRR.get());
    builder.addOperation(Mips32ShiftOp.get());
    builder.addOperation(dadd.get());
    builder.addOperation(daddi.get());
    builder.addOperation(daddiu.get());
    builder.addOperation(daddu.get());
    builder.addOperation(ddiv.get());
    builder.addOperation(ddivu.get());
    builder.addOperation(dmult.get());
    builder.addOperation(dmultu.get());
    builder.addOperation(dsub.get());
    builder.addOperation(dsubu.get());
    builder.addOperation(Mips64ArithmeticRRR.get());
    builder.addOperation(Mips64ArithmeticRRI.get());
    builder.addOperation(Mips64ArithmeticRR.get());
    builder.addOperation(Mips64ArithmeticOp.get());
    builder.addOperation(drotr.get());
    builder.addOperation(drotr32.get());
    builder.addOperation(drotrv.get());
    builder.addOperation(dsll.get());
    builder.addOperation(dsll32.get());
    builder.addOperation(dsllv.get());
    builder.addOperation(dsra.get());
    builder.addOperation(dsra32.get());
    builder.addOperation(dsrav.get());
    builder.addOperation(dsrl.get());
    builder.addOperation(dsrl32.get());
    builder.addOperation(dsrlv.get());
    builder.addOperation(Mips64ShiftRRI.get());
    builder.addOperation(Mips64ShiftRRR.get());
    builder.addOperation(Mips64ShiftOp.get());
    builder.addOperation(ext.get());
    builder.addOperation(ins.get());
    builder.addOperation(dins.get());
    builder.addOperation(dinsm.get());
    builder.addOperation(dinsu.get());
    builder.addOperation(wsbh.get());
    builder.addOperation(Mips64InsertsOp.get());
    builder.addOperation(lui.get());
    builder.addOperation(MipsAluOp.get());
    builder.addOperation(MIPS64AluOp.get());
    builder.addOperation(Mips64TArithmeticRRR.get());
    builder.addOperation(Mips64AluOpRR.get());
    builder.addOperation(Op.get());
    builder.addOperation(instruction.get());
    builder.addOperation(la.get());

    return builder.build();
  }
}
