/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mmu.sim;

import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.sim.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code DTLB} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DTLB extends Cache<JTLB.Entry, VA> {
  private static DTLB instance = null;

  public static DTLB get() {
    if (null == instance) {
      instance = new DTLB();
    }
    return instance;
  }

  private static final Indexer<VA> INDEXER = new Indexer<VA>() {
    @Override
    public BitVector getIndex(final VA va) {
      return BitVector.valueOf(0x0L, 64);
    }
  };

  private static final Matcher<JTLB.Entry, VA> MATCHER = new Matcher<JTLB.Entry, VA>() {
    @Override
    public boolean areMatching(final JTLB.Entry data, final VA va) {
      return data.VPN2.field(26, 0).equals(va.value.field(39, 13));
    }
  };

  private DTLB() {
    super(
      new BigInteger("1", 10),
      4,
      PolicyId.FIFO,
      INDEXER,
      MATCHER
      );
  }

  @Override
  protected VA newAddress() {
    return new VA();
  }

  @Override
  protected JTLB.Entry newData(final BitVector value) {
    return new JTLB.Entry(value);
  }
}
