/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mmu.sim;

import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.sim.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code JTLB} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class JTLB extends RegisterMapping<JTLB.Entry, VA> {
  private static JTLB instance = null;

  public static JTLB get() {
    if (null == instance) {
      instance = new JTLB();
    }
    return instance;
  }

  public static final class Entry implements Data {
    public final BitVector R;
    public final BitVector FILL_;
    public final BitVector VPN2;
    public final BitVector ZERO_;
    public final BitVector ASID;
    public final BitVector R0_;
    public final BitVector PFN0;
    public final BitVector C0;
    public final BitVector D0;
    public final BitVector V0;
    public final BitVector G0;
    public final BitVector R1_;
    public final BitVector PFN1;
    public final BitVector C1;
    public final BitVector D1;
    public final BitVector V1;
    public final BitVector G1;

    public Entry() {
      this.R = BitVector.newEmpty(2);
      this.FILL_ = BitVector.newEmpty(22);
      this.VPN2 = BitVector.newEmpty(27);
      this.ZERO_ = BitVector.newEmpty(5);
      this.ASID = BitVector.newEmpty(8);
      this.R0_ = BitVector.newEmpty(2);
      this.PFN0 = BitVector.newEmpty(24);
      this.C0 = BitVector.newEmpty(3);
      this.D0 = BitVector.newEmpty(1);
      this.V0 = BitVector.newEmpty(1);
      this.G0 = BitVector.newEmpty(1);
      this.R1_ = BitVector.newEmpty(2);
      this.PFN1 = BitVector.newEmpty(24);
      this.C1 = BitVector.newEmpty(3);
      this.D1 = BitVector.newEmpty(1);
      this.V1 = BitVector.newEmpty(1);
      this.G1 = BitVector.newEmpty(1);
    }

    public Entry(final BitVector value) {
      this();
      asBitVector().assign(value);
    }

    public void assign(final Entry other) {
      this.R.assign(other.R);
      this.FILL_.assign(other.FILL_);
      this.VPN2.assign(other.VPN2);
      this.ZERO_.assign(other.ZERO_);
      this.ASID.assign(other.ASID);
      this.R0_.assign(other.R0_);
      this.PFN0.assign(other.PFN0);
      this.C0.assign(other.C0);
      this.D0.assign(other.D0);
      this.V0.assign(other.V0);
      this.G0.assign(other.G0);
      this.R1_.assign(other.R1_);
      this.PFN1.assign(other.PFN1);
      this.C1.assign(other.C1);
      this.D1.assign(other.D1);
      this.V1.assign(other.V1);
      this.G1.assign(other.G1);
    }

    @Override
    public BitVector asBitVector() {
      return BitVector.newMapping(
          R,
          FILL_,
          VPN2,
          ZERO_,
          ASID,
          R0_,
          PFN0,
          C0,
          D0,
          V0,
          G0,
          R1_,
          PFN1,
          C1,
          D1,
          V1,
          G1
          );
    }

    @Override
    public String toString() {
      return String.format(
          "Entry [R=0x%s, FILL_=0x%s, VPN2=0x%s, ZERO_=0x%s, ASID=0x%s, R0_=0x%s, PFN0=0x%s, C0=0x%s, D0=0x%s, V0=0x%s, G0=0x%s, R1_=0x%s, PFN1=0x%s, C1=0x%s, D1=0x%s, V1=0x%s, G1=0x%s]",
          R.toHexString(),
          FILL_.toHexString(),
          VPN2.toHexString(),
          ZERO_.toHexString(),
          ASID.toHexString(),
          R0_.toHexString(),
          PFN0.toHexString(),
          C0.toHexString(),
          D0.toHexString(),
          V0.toHexString(),
          G0.toHexString(),
          R1_.toHexString(),
          PFN1.toHexString(),
          C1.toHexString(),
          D1.toHexString(),
          V1.toHexString(),
          G1.toHexString()
          );
    }
  }
  private static final Indexer<VA> INDEXER = new Indexer<VA>() {
    @Override
    public BitVector getIndex(final VA va) {
      return BitVector.valueOf(0x0L, 64);
    }
  };

  private static final Matcher<JTLB.Entry, VA> MATCHER = new Matcher<JTLB.Entry, VA>() {
    @Override
    public boolean areMatching(final JTLB.Entry data, final VA va) {
      return data.VPN2.field(26, 0).equals(va.value.field(39, 13));
    }
  };

  private JTLB() {
    super(
      "JTLB",
      new BigInteger("1", 10),
      64,
      PolicyId.NONE,
      INDEXER,
      MATCHER
      );
  }

  @Override
  protected VA newAddress() {
    return new VA();
  }

  @Override
  protected Entry newData(final BitVector value) {
    return new Entry(value);
  }

  @Override
  protected int getDataBitSize() {
    return 128;
  }
}
