/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mmu.sim;

import java.math.BigInteger;
import ru.ispras.fortress.data.types.bitvector.*;
import ru.ispras.microtesk.model.Execution;

/**
 * The {@code TranslateAddress} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class TranslateAddress {
  public static PA call(
    final VA va) {
    final PA pa = new PA();

    if (USEG.get().isHit(va)) {
      pa.assign(USEG.get().getData(va));
      Execution.trace("USEG: va=%s, pa=%s", va.value.toHexString(), pa.value.toHexString());
    } else if (KSEG0.get().isHit(va)) {
      pa.assign(KSEG0.get().getData(va));
      Execution.trace("KSEG0: va=%s, pa=%s", va.value.toHexString(), pa.value.toHexString());
    } else if (KSEG1.get().isHit(va)) {
      pa.assign(KSEG1.get().getData(va));
      Execution.trace("KSEG1: va=%s, pa=%s", va.value.toHexString(), pa.value.toHexString());
    } else if (XKPHYS.get().isHit(va)) {
      pa.assign(XKPHYS.get().getData(va));
      Execution.trace("XKPHYS: va=%s, pa=%s", va.value.toHexString(), pa.value.toHexString());
    } else {
      Execution.trace("ERROR: va=%s, pa=%s", va.value.toHexString(), pa.value.toHexString());
    }
    return pa;
  }
}
