/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mmu.spec;

import java.util.Collections;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.fortress.data.DataType;
import ru.ispras.fortress.expression.NodeVariable;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.fortress.expression.Nodes;
import ru.ispras.fortress.expression.NodeValue;
import ru.ispras.microtesk.mmu.model.spec.MmuBinding;
import ru.ispras.microtesk.mmu.model.spec.MmuBuffer;
import ru.ispras.microtesk.mmu.model.spec.MmuStruct;

/**
 * The {@code DTLB} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DTLB extends MmuBuffer {
  private static DTLB INSTANCE = null;

  public static DTLB get() {
    if (null == INSTANCE) {
      INSTANCE = new DTLB();
    }
    return INSTANCE;
  }

  private final VA va = VA.get();

  public static final class Entry extends MmuStruct {
    public final NodeVariable R;
    public final NodeVariable FILL_;
    public final NodeVariable VPN2;
    public final NodeVariable ZERO_;
    public final NodeVariable ASID;
    public final NodeVariable R0_;
    public final NodeVariable PFN0;
    public final NodeVariable C0;
    public final NodeVariable D0;
    public final NodeVariable V0;
    public final NodeVariable G0;
    public final NodeVariable R1_;
    public final NodeVariable PFN1;
    public final NodeVariable C1;
    public final NodeVariable D1;
    public final NodeVariable V1;
    public final NodeVariable G1;

    public Entry(final String name) {
      super(name);

      this.R = new NodeVariable(name + ".R", DataType.bitVector(2));
      this.FILL_ = new NodeVariable(name + ".FILL_", DataType.bitVector(22));
      this.VPN2 = new NodeVariable(name + ".VPN2", DataType.bitVector(27));
      this.ZERO_ = new NodeVariable(name + ".ZERO_", DataType.bitVector(5));
      this.ASID = new NodeVariable(name + ".ASID", DataType.bitVector(8));
      this.R0_ = new NodeVariable(name + ".R0_", DataType.bitVector(2));
      this.PFN0 = new NodeVariable(name + ".PFN0", DataType.bitVector(24));
      this.C0 = new NodeVariable(name + ".C0", DataType.bitVector(3));
      this.D0 = new NodeVariable(name + ".D0", DataType.bitVector(1));
      this.V0 = new NodeVariable(name + ".V0", DataType.bitVector(1));
      this.G0 = new NodeVariable(name + ".G0", DataType.bitVector(1));
      this.R1_ = new NodeVariable(name + ".R1_", DataType.bitVector(2));
      this.PFN1 = new NodeVariable(name + ".PFN1", DataType.bitVector(24));
      this.C1 = new NodeVariable(name + ".C1", DataType.bitVector(3));
      this.D1 = new NodeVariable(name + ".D1", DataType.bitVector(1));
      this.V1 = new NodeVariable(name + ".V1", DataType.bitVector(1));
      this.G1 = new NodeVariable(name + ".G1", DataType.bitVector(1));

      addField(R);
      addField(FILL_);
      addField(VPN2);
      addField(ZERO_);
      addField(ASID);
      addField(R0_);
      addField(PFN0);
      addField(C0);
      addField(D0);
      addField(V0);
      addField(G0);
      addField(R1_);
      addField(PFN1);
      addField(C1);
      addField(D1);
      addField(V1);
      addField(G1);
    }
  }

  public final NodeVariable R;
  public final NodeVariable FILL_;
  public final NodeVariable VPN2;
  public final NodeVariable ZERO_;
  public final NodeVariable ASID;
  public final NodeVariable R0_;
  public final NodeVariable PFN0;
  public final NodeVariable C0;
  public final NodeVariable D0;
  public final NodeVariable V0;
  public final NodeVariable G0;
  public final NodeVariable R1_;
  public final NodeVariable PFN1;
  public final NodeVariable C1;
  public final NodeVariable D1;
  public final NodeVariable V1;
  public final NodeVariable G1;

  private DTLB() {
    this("DTLB");
  }

  private DTLB(final String name) {
    super(
        name,
        Kind.UNMAPPED,
        4L,
        1L,
        VA.get(),
        Nodes.bvextract(39, 13, VA.get().value),
        Nodes.FALSE,
        Nodes.bvconcat(Nodes.bvextract(63, 40, VA.get().value), Nodes.bvextract(12, 0, VA.get().value)),
        Collections.<MmuBinding>emptyList(), // set up with setMatchBindings
        true,
        JTLB.get()
    );

    this.R = new NodeVariable(name + ".R", DataType.bitVector(2));
    this.FILL_ = new NodeVariable(name + ".FILL_", DataType.bitVector(22));
    this.VPN2 = new NodeVariable(name + ".VPN2", DataType.bitVector(27));
    this.ZERO_ = new NodeVariable(name + ".ZERO_", DataType.bitVector(5));
    this.ASID = new NodeVariable(name + ".ASID", DataType.bitVector(8));
    this.R0_ = new NodeVariable(name + ".R0_", DataType.bitVector(2));
    this.PFN0 = new NodeVariable(name + ".PFN0", DataType.bitVector(24));
    this.C0 = new NodeVariable(name + ".C0", DataType.bitVector(3));
    this.D0 = new NodeVariable(name + ".D0", DataType.bitVector(1));
    this.V0 = new NodeVariable(name + ".V0", DataType.bitVector(1));
    this.G0 = new NodeVariable(name + ".G0", DataType.bitVector(1));
    this.R1_ = new NodeVariable(name + ".R1_", DataType.bitVector(2));
    this.PFN1 = new NodeVariable(name + ".PFN1", DataType.bitVector(24));
    this.C1 = new NodeVariable(name + ".C1", DataType.bitVector(3));
    this.D1 = new NodeVariable(name + ".D1", DataType.bitVector(1));
    this.V1 = new NodeVariable(name + ".V1", DataType.bitVector(1));
    this.G1 = new NodeVariable(name + ".G1", DataType.bitVector(1));

    addField(R);
    addField(FILL_);
    addField(VPN2);
    addField(ZERO_);
    addField(ASID);
    addField(R0_);
    addField(PFN0);
    addField(C0);
    addField(D0);
    addField(V0);
    addField(G0);
    addField(R1_);
    addField(PFN1);
    addField(C1);
    addField(D1);
    addField(V1);
    addField(G1);

    setMatchBindings(Arrays.<MmuBinding>asList(
        new MmuBinding(Nodes.bvextract(26, 0, VPN2), Nodes.bvextract(39, 13, VA.get().value))));
  }
}
