/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mmu.spec;

import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.fortress.data.Data;
import ru.ispras.fortress.data.DataType;
import ru.ispras.fortress.expression.Nodes;
import ru.ispras.fortress.expression.NodeValue;
import ru.ispras.fortress.expression.NodeVariable;
import ru.ispras.microtesk.mmu.model.spec.MmuSegment;
import ru.ispras.microtesk.mmu.model.spec.MmuSubsystem;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.mmu.basis.BufferAccessEvent;
import ru.ispras.microtesk.mmu.model.spec.MmuAction;
import ru.ispras.microtesk.mmu.model.spec.MmuBinding;
import ru.ispras.microtesk.mmu.model.spec.MmuBufferAccess;
import ru.ispras.microtesk.mmu.model.spec.MmuGuard;
import ru.ispras.microtesk.mmu.model.spec.MmuSegment;
import ru.ispras.microtesk.mmu.model.spec.MmuTransition;
import java.util.ArrayList;
import java.util.List;

/**
 * The {@code KSEG1} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class KSEG1 extends MmuSegment {
  private static KSEG1 INSTANCE = null;

  public static KSEG1 get() {
    if (null == INSTANCE) {
      INSTANCE = new KSEG1();
    }
    return INSTANCE;
  }

  private KSEG1() {
    this("KSEG1");
  }

  private KSEG1(final String name) {
    super(
        "KSEG1",
        VA.get(),
        PA.get(),
        BitVector.valueOf(0xFFFFFFFFA0000000L, 64),
        BitVector.valueOf(0xFFFFFFFFBFFFFFFFL, 64)
        );
  }

  private int callIndex = 0;

  public final Function newCall(final MmuSubsystem.Builder builder, final VA va, final PA pa) {
    return new Function(builder, callIndex++, va, pa);
  }

  public static final class Function {
    public final VA va;
    public final PA pa;

    private final NodeVariable zero;

    public final MmuAction START;
    public final MmuAction STOP;

    private final MmuAction ASSIGN_0;
    private final MmuAction ASSIGN_1;
    private final MmuAction ASSIGN_2;

    private Function(final MmuSubsystem.Builder builder, final int instanceIndex, final VA va, final PA pa) {
      this(builder, String.format("KSEG1_%d", instanceIndex), va, pa);
    }

    private Function(final MmuSubsystem.Builder builder, final String name, final VA va, final PA pa) {
      this.va = va;
      this.pa = pa;

      this.zero = new NodeVariable(name + ".zero", DataType.bitVector(7));
      builder.registerVariable(zero);


      this.START = new MmuAction(name + ".START");
      builder.registerAction(START);
      this.STOP = new MmuAction(name + ".STOP");
      builder.registerAction(STOP);

      this.ASSIGN_0 = new MmuAction(name + ".ASSIGN_0", new MmuBinding(zero, NodeValue.newInteger(0)));
      builder.registerAction(ASSIGN_0);
      builder.registerTransition(new MmuTransition(START, ASSIGN_0));
      this.ASSIGN_1 = new MmuAction(name + ".ASSIGN_1", new MmuBinding(pa.value, Nodes.bvconcat(zero, Nodes.bvextract(28, 0, va.value))));
      builder.registerAction(ASSIGN_1);
      builder.registerTransition(new MmuTransition(ASSIGN_0, ASSIGN_1));
      this.ASSIGN_2 = new MmuAction(name + ".ASSIGN_2", new MmuBinding(pa.cca, NodeValue.newInteger(2)));
      builder.registerAction(ASSIGN_2);
      builder.registerTransition(new MmuTransition(ASSIGN_1, ASSIGN_2));
      builder.registerTransition(new MmuTransition(ASSIGN_2, STOP));
    }
  }
}
