/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mmu.spec;

import java.util.Collections;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.fortress.data.DataType;
import ru.ispras.fortress.expression.NodeVariable;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.fortress.expression.Nodes;
import ru.ispras.fortress.expression.NodeValue;
import ru.ispras.microtesk.mmu.model.spec.MmuBinding;
import ru.ispras.microtesk.mmu.model.spec.MmuBuffer;
import ru.ispras.microtesk.mmu.model.spec.MmuStruct;

/**
 * The {@code L2} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class L2 extends MmuBuffer {
  private static L2 INSTANCE = null;

  public static L2 get() {
    if (null == INSTANCE) {
      INSTANCE = new L2();
    }
    return INSTANCE;
  }

  private final PA pa = PA.get();

  public static final class Entry extends MmuStruct {
    public final NodeVariable TAG;
    public final NodeVariable DATA;

    public Entry(final String name) {
      super(name);

      this.TAG = new NodeVariable(name + ".TAG", DataType.bitVector(19));
      this.DATA = new NodeVariable(name + ".DATA", DataType.bitVector(256));

      addField(TAG);
      addField(DATA);
    }
  }

  public final NodeVariable TAG;
  public final NodeVariable DATA;

  private L2() {
    this("L2");
  }

  private L2(final String name) {
    super(
        name,
        Kind.UNMAPPED,
        4L,
        4096L,
        PA.get(),
        Nodes.bvextract(35, 17, PA.get().value),
        Nodes.bvextract(16, 5, PA.get().value),
        Nodes.bvextract(4, 0, PA.get().value),
        Collections.<MmuBinding>emptyList(), // set up with setMatchBindings
        true,
        null
    );

    this.TAG = new NodeVariable(name + ".TAG", DataType.bitVector(19));
    this.DATA = new NodeVariable(name + ".DATA", DataType.bitVector(256));

    addField(TAG);
    addField(DATA);

    setMatchBindings(Arrays.<MmuBinding>asList(
        new MmuBinding(TAG, Nodes.bvextract(35, 17, PA.get().value))));
  }
}
