/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mmu.spec;

import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.fortress.data.Data;
import ru.ispras.fortress.data.DataType;
import ru.ispras.fortress.expression.Nodes;
import ru.ispras.fortress.expression.NodeValue;
import ru.ispras.fortress.expression.NodeVariable;
import ru.ispras.microtesk.mmu.model.spec.MmuSegment;
import ru.ispras.microtesk.mmu.model.spec.MmuSubsystem;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.mmu.basis.BufferAccessEvent;
import ru.ispras.microtesk.mmu.model.spec.MmuAction;
import ru.ispras.microtesk.mmu.model.spec.MmuBinding;
import ru.ispras.microtesk.mmu.model.spec.MmuBufferAccess;
import ru.ispras.microtesk.mmu.model.spec.MmuGuard;
import ru.ispras.microtesk.mmu.model.spec.MmuSegment;
import ru.ispras.microtesk.mmu.model.spec.MmuTransition;
import java.util.ArrayList;
import java.util.List;

/**
 * The {@code XKPHYS} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class XKPHYS extends MmuSegment {
  private static XKPHYS INSTANCE = null;

  public static XKPHYS get() {
    if (null == INSTANCE) {
      INSTANCE = new XKPHYS();
    }
    return INSTANCE;
  }

  private XKPHYS() {
    this("XKPHYS");
  }

  private XKPHYS(final String name) {
    super(
        "XKPHYS",
        VA.get(),
        PA.get(),
        BitVector.valueOf(0x8000000000000000L, 64),
        BitVector.valueOf(0xBFFFFFFFFFFFFFFFL, 64)
        );
  }

  private int callIndex = 0;

  public final Function newCall(final MmuSubsystem.Builder builder, final VA va, final PA pa) {
    return new Function(builder, callIndex++, va, pa);
  }

  public static final class Function {
    public final VA va;
    public final PA pa;

    public final MmuAction START;
    public final MmuAction STOP;

    private final MmuAction ASSIGN_0;
    private final MmuAction ASSIGN_1;

    private Function(final MmuSubsystem.Builder builder, final int instanceIndex, final VA va, final PA pa) {
      this(builder, String.format("XKPHYS_%d", instanceIndex), va, pa);
    }

    private Function(final MmuSubsystem.Builder builder, final String name, final VA va, final PA pa) {
      this.va = va;
      this.pa = pa;

      this.START = new MmuAction(name + ".START");
      builder.registerAction(START);
      this.STOP = new MmuAction(name + ".STOP");
      builder.registerAction(STOP);

      this.ASSIGN_0 = new MmuAction(name + ".ASSIGN_0", new MmuBinding(pa.value, Nodes.bvextract(35, 0, va.value)));
      builder.registerAction(ASSIGN_0);
      builder.registerTransition(new MmuTransition(START, ASSIGN_0));
      this.ASSIGN_1 = new MmuAction(name + ".ASSIGN_1", new MmuBinding(pa.cca, Nodes.bvextract(61, 59, va.value)));
      builder.registerAction(ASSIGN_1);
      builder.registerTransition(new MmuTransition(ASSIGN_0, ASSIGN_1));
      builder.registerTransition(new MmuTransition(ASSIGN_1, STOP));
    }
  }
}
