/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mmu.spec;

import java.util.ArrayList;
import java.util.List;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.fortress.data.Data;
import ru.ispras.fortress.data.DataType;
import ru.ispras.fortress.data.Variable;
import ru.ispras.fortress.expression.NodeVariable;
import ru.ispras.fortress.expression.Nodes;
import ru.ispras.fortress.expression.NodeValue;
import ru.ispras.microtesk.mmu.model.spec.MmuSubsystem;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.mmu.basis.BufferAccessEvent;
import ru.ispras.microtesk.mmu.model.spec.MmuAction;
import ru.ispras.microtesk.mmu.model.spec.MmuBinding;
import ru.ispras.microtesk.mmu.model.spec.MmuBufferAccess;
import ru.ispras.microtesk.mmu.model.spec.MmuGuard;
import ru.ispras.microtesk.mmu.model.spec.MmuSegment;
import ru.ispras.microtesk.mmu.model.spec.MmuTransition;

/**
 * The {@code putWordIntoLine} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class putWordIntoLine {
  private static putWordIntoLine INSTANCE = null;

  public static putWordIntoLine get() {
    if (null == INSTANCE) {
      INSTANCE = new putWordIntoLine();
    }
    return INSTANCE;
  }

  private int callIndex = 0;

  public final Function newCall(
      final MmuSubsystem.Builder builder,
      final NodeVariable putWordIntoLine,
      final NodeVariable wordIndex,
      final NodeVariable line,
      final NodeVariable data) {
    return new Function(builder, callIndex++, putWordIntoLine, wordIndex, line, data);
  }

  public static final class Function {
    public final NodeVariable putWordIntoLine;
    public final NodeVariable wordIndex;
    public final NodeVariable line;
    public final NodeVariable data;

    private final NodeVariable intline;


    public final MmuAction START;
    public final MmuAction STOP;

    private final MmuAction ASSIGN_0;
    private final MmuAction BRANCH_0;
    private final MmuAction ASSIGN_1;
    private final MmuAction JOIN_0;
    private final MmuAction BRANCH_1;
    private final MmuAction ASSIGN_2;
    private final MmuAction BRANCH_2;
    private final MmuAction ASSIGN_3;
    private final MmuAction BRANCH_3;
    private final MmuAction ASSIGN_4;
    private final MmuAction ASSIGN_5;

    private Function(
        final MmuSubsystem.Builder builder,
        final int instanceIndex,
        final NodeVariable putWordIntoLine,
        final NodeVariable wordIndex,
        final NodeVariable line,
        final NodeVariable data) {
      final String name = String.format("putWordIntoLine_%d", instanceIndex);
      this.putWordIntoLine = putWordIntoLine; 
      this.wordIndex = wordIndex; 
      this.line = line; 
      this.data = data; 

      this.intline = new NodeVariable(name + ".intline", DataType.bitVector(256));
      builder.registerVariable(intline);

      this.START = new MmuAction(name + ".START");
      builder.registerAction(START);
      this.STOP = new MmuAction(name + ".STOP");
      builder.registerAction(STOP);

      this.ASSIGN_0 = new MmuAction(name + ".ASSIGN_0", new MmuBinding(intline, line));
      builder.registerAction(ASSIGN_0);
      builder.registerTransition(new MmuTransition(START, ASSIGN_0));
      this.BRANCH_0 = new MmuAction(name + ".BRANCH_0");
      builder.registerAction(BRANCH_0);
      builder.registerTransition(new MmuTransition(ASSIGN_0, BRANCH_0, new MmuGuard(Nodes.eq(wordIndex, NodeValue.newBitVector(0x0, 2)))));
      this.ASSIGN_1 = new MmuAction(name + ".ASSIGN_1", new MmuBinding(Nodes.bvextract(63, 0, intline), data));
      builder.registerAction(ASSIGN_1);
      builder.registerTransition(new MmuTransition(BRANCH_0, ASSIGN_1));
      this.JOIN_0 = new MmuAction(name + ".JOIN_0");
      builder.registerAction(JOIN_0);
      builder.registerTransition(new MmuTransition(ASSIGN_1, JOIN_0));
      this.BRANCH_1 = new MmuAction(name + ".BRANCH_1");
      builder.registerAction(BRANCH_1);
      builder.registerTransition(new MmuTransition(ASSIGN_0, BRANCH_1, new MmuGuard(Nodes.eq(wordIndex, NodeValue.newBitVector(0x1, 2)))));
      this.ASSIGN_2 = new MmuAction(name + ".ASSIGN_2", new MmuBinding(Nodes.bvextract(127, 64, intline), data));
      builder.registerAction(ASSIGN_2);
      builder.registerTransition(new MmuTransition(BRANCH_1, ASSIGN_2));
      builder.registerTransition(new MmuTransition(ASSIGN_2, JOIN_0));
      this.BRANCH_2 = new MmuAction(name + ".BRANCH_2");
      builder.registerAction(BRANCH_2);
      builder.registerTransition(new MmuTransition(ASSIGN_0, BRANCH_2, new MmuGuard(Nodes.eq(wordIndex, NodeValue.newBitVector(0x2, 2)))));
      this.ASSIGN_3 = new MmuAction(name + ".ASSIGN_3", new MmuBinding(Nodes.bvextract(191, 128, intline), data));
      builder.registerAction(ASSIGN_3);
      builder.registerTransition(new MmuTransition(BRANCH_2, ASSIGN_3));
      builder.registerTransition(new MmuTransition(ASSIGN_3, JOIN_0));
      this.BRANCH_3 = new MmuAction(name + ".BRANCH_3");
      builder.registerAction(BRANCH_3);
      builder.registerTransition(new MmuTransition(ASSIGN_0, BRANCH_3, new MmuGuard(Nodes.and(Nodes.noteq(wordIndex, NodeValue.newBitVector(0x0, 2)), Nodes.noteq(wordIndex, NodeValue.newBitVector(0x1, 2)), Nodes.noteq(wordIndex, NodeValue.newBitVector(0x2, 2))))));
      this.ASSIGN_4 = new MmuAction(name + ".ASSIGN_4", new MmuBinding(Nodes.bvextract(255, 192, intline), data));
      builder.registerAction(ASSIGN_4);
      builder.registerTransition(new MmuTransition(BRANCH_3, ASSIGN_4));
      builder.registerTransition(new MmuTransition(ASSIGN_4, JOIN_0));
      this.ASSIGN_5 = new MmuAction(name + ".ASSIGN_5", new MmuBinding(putWordIntoLine, intline));
      builder.registerAction(ASSIGN_5);
      builder.registerTransition(new MmuTransition(JOIN_0, ASSIGN_5));
      builder.registerTransition(new MmuTransition(ASSIGN_5, STOP));
    }
  }
}
