/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.memory.Location;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class C0_R extends IsaPrimitive {
  public static final String NAME = "C0_R";

  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.MODE,
          "C0_R",
          C0_R.class,
          DWORD
          );
      addArgument("r", Type.CARD(5));
      addArgument("s", Type.CARD(3));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate r = (Immediate) getArgument("r", args);
      final Immediate s = (Immediate) getArgument("s", args);
      return new C0_R(r, s);
    }
  }

  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate r;
  public final Immediate s;

  public C0_R(final Immediate r, final Immediate s) {
    this.r = r;
    this.s = s;

    addArgument("r", r);
    addArgument("s", s);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("$%d, %d", r.access().load().bigIntegerValue(), s.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%5s00000000%3s", r.access().load().toString(), s.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public Location access(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    return annotate(pe__.CPR.access(Data.valueOf(Type.CARD(8), 0x8).multiply(Data.zeroExtend(Type.CARD(8), r.access().load())).add(Data.zeroExtend(Type.CARD(8), s.access().load()))), vars__);
  }
}