/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.memory.Location;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class R extends IsaPrimitive {
  public static final String NAME = "R";

  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.MODE,
          "R",
          R.class,
          DWORD
          );
      addArgument("i", Type.CARD(5));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate i = (Immediate) getArgument("i", args);
      return new R(i);
    }
  }

  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate i;

  public R(final Immediate i) {
    this.i = i;

    addArgument("i", i);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%s", (i.access().load().equals(Data.valueOf(Type.CARD(5), 0x0)) ? new ZERO().text(vars__) : (i.access().load().equals(Data.valueOf(Type.CARD(5), 0x1)) ? new AT().text(vars__) : ((i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x2)) >= 0) && (i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x3)) <= 0) ? new VREG(new Immediate(Data.coerce(BIT, i.access().load().subtract(Data.valueOf(Type.CARD(5), 0x2))))).text(vars__) : ((i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x4)) >= 0) && (i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x7)) <= 0) ? new AREG(new Immediate(Data.coerce(Type.CARD(2), i.access().load().subtract(Data.valueOf(Type.CARD(5), 0x4))))).text(vars__) : ((i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x8)) >= 0) && (i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0xf)) <= 0) ? new TREG(new Immediate(Data.coerce(Type.CARD(4), i.access().load().subtract(Data.valueOf(Type.CARD(5), 0x8))))).text(vars__) : ((i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x10)) >= 0) && (i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x17)) <= 0) ? new SREG(new Immediate(Data.coerce(Type.CARD(3), i.access().load().subtract(Data.valueOf(Type.CARD(5), 0x8))))).text(vars__) : ((i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x18)) >= 0) && (i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x19)) <= 0) ? new TREG(new Immediate(Data.coerce(Type.CARD(4), i.access().load().subtract(Data.valueOf(Type.CARD(5), 0x10))))).text(vars__) : ((i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x1a)) >= 0) && (i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x1b)) <= 0) ? new KREG(new Immediate(Data.coerce(BIT, i.access().load().subtract(Data.valueOf(Type.CARD(5), 0x1a))))).text(vars__) : (i.access().load().equals(Data.valueOf(Type.CARD(5), 0x1c)) ? new GP().text(vars__) : (i.access().load().equals(Data.valueOf(Type.CARD(5), 0x1d)) ? new SP().text(vars__) : (i.access().load().equals(Data.valueOf(Type.CARD(5), 0x1e)) ? new FP().text(vars__) : (i.access().load().equals(Data.valueOf(Type.CARD(5), 0x1f)) ? new RA().text(vars__) : "error")))))))))))));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%5s", i.access().load().toString());
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public Location access(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    return annotate(pe__.GPR.access(i.access().load()), vars__);
  }
}