/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class add_exception extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "add_exception",
          add_exception.class,
          null
          );
      addArgument("excep", Type.CARD(8));}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate excep = (Immediate) getArgument("excep", args);

      return new add_exception(excep);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate excep;

  public add_exception(final Immediate excep) {
    this.excep = excep;

    addArgument("excep", excep);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    if (excep.access().load().equals(Data.valueOf(Type.CARD(8), 0x0))) {
      if (pe__.C0_STATUS_CU0.access().load().equals(Data.valueOf(BIT, 0x0)) && !(pe__.C0_DEBUG_DM.access().load().equals(Data.valueOf(BIT, 0x0)) && ((pe__.C0_STATUS_KSU.access().load().equals(Data.valueOf(Type.CARD(2), 0x0)) || pe__.C0_STATUS_ERL.access().load().equals(Data.valueOf(BIT, 0x1))) || pe__.C0_STATUS_EXL.access().load().equals(Data.valueOf(BIT, 0x1))))) {
        Execution.exception("Coprocessor Unusable: CU0");
      }
    }
    if (excep.access().load().equals(Data.valueOf(Type.CARD(8), 0x1)) && pe__.C0_STATUS_CU1.access().load().equals(Data.valueOf(BIT, 0x0))) {
      Execution.exception("Coprocessor Unusable: CU1");
    }
    if (excep.access().load().equals(Data.valueOf(Type.CARD(8), 0x2)) && pe__.C0_STATUS_CU2.access().load().equals(Data.valueOf(BIT, 0x0))) {
      Execution.exception("Coprocessor Unusable: CU2");
    }
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}