/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.memory.Location;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class bc1t extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "bc1t",
          bc1t.class,
          null
          );
      addArgument("cc", Type.CARD(3));
      addArgument("offset", BRANCH_FPU_OFFSET.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate cc = (Immediate) getArgument("cc", args);
      final IsaPrimitive offset = (IsaPrimitive) getArgument("offset", args);

      return new bc1t(cc, offset);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "bc1t",
          instruction.class,
          null
          );
      addArgument("cc", Type.CARD(3));
      addArgument("offset", BRANCH_FPU_OFFSET.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate cc = (Immediate) getArgument("cc", args);
      final IsaPrimitive offset = (IsaPrimitive) getArgument("offset", args);

      return new instruction(
        new bc1t(
          cc,
          offset
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate cc;
  public final IsaPrimitive offset;

  public bc1t(final Immediate cc, final IsaPrimitive offset) {
    this.cc = cc;
    this.offset = offset;

    addArgument("cc", cc);
    addArgument("offset", offset);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.encoding_nd.access().store(Data.valueOf(BIT, 0x0));
    vars__.encoding_tf.access().store(Data.valueOf(BIT, 0x1));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("bc1t %d, %s", cc.access().load().bigIntegerValue(), offset.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("01000101000%3s%1s%1s%16s", cc.access().load().toString(), vars__.encoding_nd.access().load().toString(), vars__.encoding_tf.access().load().toString(), offset.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    pe__.BRANCH_INSTRUCTION.access().store(Data.valueOf(BIT, 0x1));
    new FPConditionCode(cc).execute(pe__, vars__);
    if (pe__.FPConditionCode_value.access().load().equals(vars__.encoding_tf.access().load())) {
      pe__.BRANCH.access().store(Data.valueOf(BIT, 0x1));
      pe__.NEXTPC.access().store(pe__.CIA.access().load().add(Data.signExtend(DWORD, offset.access(pe__, vars__).load()).shiftLeft(Data.valueOf(DWORD, 0x2))));
    }
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}