/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.memory.Location;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class cache extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "cache",
          cache.class,
          null
          );
      addArgument("operation", Type.CARD(5));
      addArgument("offset", SHORT);
      addArgument("base", R.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate operation = (Immediate) getArgument("operation", args);
      final Immediate offset = (Immediate) getArgument("offset", args);
      final R base = (R) getArgument("base", args);

      return new cache(operation, offset, base);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "cache",
          instruction.class,
          null
          );
      addArgument("operation", Type.CARD(5));
      addArgument("offset", SHORT);
      addArgument("base", R.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate operation = (Immediate) getArgument("operation", args);
      final Immediate offset = (Immediate) getArgument("offset", args);
      final R base = (R) getArgument("base", args);

      return new instruction(
        new cache(
          operation,
          offset,
          base
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate operation;
  public final Immediate offset;
  public final R base;

  public cache(final Immediate operation, final Immediate offset, final R base) {
    this.operation = operation;
    this.offset = offset;
    this.base = base;

    addArgument("operation", operation);
    addArgument("offset", offset);
    addArgument("base", base);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("cache %d, %d(%s)", operation.access().load().bigIntegerValue(), offset.access().load().bigIntegerValue(), base.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("101111%5s%5s%16s", base.image(vars__), operation.access().load().toString(), offset.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    new add_exception(new Immediate(Data.valueOf(Type.CARD(8), 0x0))).execute(pe__, vars__);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}