/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class clo_count_leading_ones extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "clo_count_leading_ones",
          clo_count_leading_ones.class,
          null
          );
      addArgument("rs_value", WORD);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate rs_value = (Immediate) getArgument("rs_value", args);

      return new clo_count_leading_ones(rs_value);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate rs_value;

  public clo_count_leading_ones(final Immediate rs_value) {
    this.rs_value = rs_value;

    addArgument("rs_value", rs_value);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.temp.access().store(Data.valueOf(WORD, 0x0));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(0, 0).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(1, 1).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(2, 2).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(3, 3).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(4, 4).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(5, 5).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(6, 6).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(7, 7).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(8, 8).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(9, 9).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(10, 10).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(11, 11).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(12, 12).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(13, 13).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(14, 14).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(15, 15).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(16, 16).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(17, 17).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(18, 18).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(19, 19).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(20, 20).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(21, 21).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(22, 22).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(23, 23).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(24, 24).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(25, 25).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(26, 26).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(27, 27).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(28, 28).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(29, 29).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(30, 30).load())));
    vars__.temp.access().store(vars__.temp.access().load().add(Data.zeroExtend(WORD, rs_value.access().bitField(31, 31).load())));
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}