/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class dins extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "dins",
          dins.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("pos", Type.CARD(5));
      addArgument("size", Type.CARD(5));
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate pos = (Immediate) getArgument("pos", args);
      final Immediate size = (Immediate) getArgument("size", args);

      return new dins(rt, rs, pos, size);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "dins",
          instruction.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("pos", Type.CARD(5));
      addArgument("size", Type.CARD(5));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate pos = (Immediate) getArgument("pos", args);
      final Immediate size = (Immediate) getArgument("size", args);

      return new instruction(
        new dins(
          rt,
          rs,
          pos,
          size
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rt;
  public final R rs;
  public final Immediate pos;
  public final Immediate size;

  public dins(final R rt, final R rs, final Immediate pos, final Immediate size) {
    this.rt = rt;
    this.rs = rs;
    this.pos = pos;
    this.size = size;

    addArgument("rt", rt);
    addArgument("rs", rs);
    addArgument("pos", pos);
    addArgument("size", size);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("dins %s, %s, %d, %d", rt.text(vars__), rs.text(vars__), pos.access().load().bigIntegerValue(), size.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("011111%5s%5s%5s%5s000111", rs.image(vars__), rt.image(vars__), pos.access().load().add(size.access().load()).subtract(Data.valueOf(Type.CARD(5), 0x1)).toString(), pos.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    if ((pos.access().load().compareTo(pos.access().load().add(size.access().load()).subtract(Data.valueOf(Type.CARD(5), 0x1))) > 0)) {
      Execution.unpredicted();
    }
    vars__.temp64.access().store(rt.access(pe__, vars__).bitField(63, 0).load());
    vars__.temp1.access().store(Data.valueOf(WORD, 0xffffffffL));
    vars__.temp1.access().store(vars__.temp1.access().load().shiftLeft(Data.valueOf(Type.CARD(5), 0x0).subtract(pos.access().load()).subtract(size.access().load())));
    vars__.temp1.access().store(vars__.temp1.access().load().shiftRight(Data.valueOf(Type.CARD(5), 0x0).subtract(size.access().load())));
    vars__.temp3.access().store(rs.access(pe__, vars__).bitField(31, 0).load().and(vars__.temp1.access().load()));
    vars__.temp1.access().store(vars__.temp1.access().load().shiftLeft(pos.access().load()));
    vars__.temp3.access().store(vars__.temp3.access().load().shiftLeft(pos.access().load()));
    vars__.temp64_1.access().store(Data.valueOf(DWORD, 0x0));
    vars__.temp64_1.access().bitField(31, 0).store(vars__.temp1.access().bitField(31, 0).load());
    vars__.temp64.access().store(vars__.temp64.access().load().and(vars__.temp64_1.access().load().not()));
    vars__.temp64.access().store(vars__.temp64.access().load().or(Data.zeroExtend(DWORD, vars__.temp3.access().load())));
    rt.access(pe__, vars__).store(vars__.temp64.access().load());
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}