/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class div_fmt extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "div_fmt",
          div_fmt.class,
          null
          );
      addArgument("op_fmt", FMT_FORMAT.INFO);
      addArgument("fd", FR.INFO);
      addArgument("fs", FR.INFO);
      addArgument("ft", FR.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive op_fmt = (IsaPrimitive) getArgument("op_fmt", args);
      final FR fd = (FR) getArgument("fd", args);
      final FR fs = (FR) getArgument("fs", args);
      final FR ft = (FR) getArgument("ft", args);

      return new div_fmt(op_fmt, fd, fs, ft);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "div_fmt",
          instruction.class,
          null
          );
      addArgument("op_fmt", FMT_FORMAT.INFO);
      addArgument("fd", FR.INFO);
      addArgument("fs", FR.INFO);
      addArgument("ft", FR.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive op_fmt = (IsaPrimitive) getArgument("op_fmt", args);
      final FR fd = (FR) getArgument("fd", args);
      final FR fs = (FR) getArgument("fs", args);
      final FR ft = (FR) getArgument("ft", args);

      return new instruction(
        new div_fmt(
          op_fmt,
          fd,
          fs,
          ft
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final IsaPrimitive op_fmt;
  public final FR fd;
  public final FR fs;
  public final FR ft;

  public div_fmt(final IsaPrimitive op_fmt, final FR fd, final FR fs, final FR ft) {
    this.op_fmt = op_fmt;
    this.fd = fd;
    this.fs = fs;
    this.ft = ft;

    addArgument("op_fmt", op_fmt);
    addArgument("fd", fd);
    addArgument("fs", fs);
    addArgument("ft", ft);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("div.%s %s, %s, %s", op_fmt.text(vars__), fd.text(vars__), fs.text(vars__), ft.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("010001%5s%5s%5s%5s000011", op_fmt.image(vars__), fs.image(vars__), ft.image(vars__), fd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    op_fmt.execute(pe__, vars__);
    if (vars__.fmt_fpu.access().load().equals(Data.valueOf(Type.CARD(5), 0x10))) {
      vars__.temp_fp_s.access().store(Data.cast(FLOAT32, fs.access(pe__, vars__).bitField(31, 0).load()).divide(Data.cast(FLOAT32, ft.access(pe__, vars__).bitField(31, 0).load())));
      fd.access(pe__, vars__).bitField(31, 0).store(Data.floatToInt(WORD, vars__.temp_fp_s.access().load()));
    } else if (vars__.fmt_fpu.access().load().equals(Data.valueOf(Type.CARD(5), 0x11))) {
      vars__.temp_fp_d.access().store(Data.intToFloat(FLOAT64, fs.access(pe__, vars__).load()).divide(Data.intToFloat(FLOAT64, ft.access(pe__, vars__).load())));
      fd.access(pe__, vars__).store(Data.floatToInt(DWORD, vars__.temp_fp_d.access().load()));
    } else if (vars__.fmt_fpu.access().load().equals(Data.valueOf(Type.CARD(5), 0x16))) {
      Execution.unpredicted();
    } else {
      Execution.unpredicted();
    }
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}