/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class mfc0_2 extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "mfc0_2",
          mfc0_2.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("rd", Type.CARD(5));
      addArgument("sel", Type.CARD(3));
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final Immediate rd = (Immediate) getArgument("rd", args);
      final Immediate sel = (Immediate) getArgument("sel", args);

      return new mfc0_2(rt, rd, sel);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "mfc0_2",
          instruction.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("rd", Type.CARD(5));
      addArgument("sel", Type.CARD(3));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final Immediate rd = (Immediate) getArgument("rd", args);
      final Immediate sel = (Immediate) getArgument("sel", args);

      return new instruction(
        new mfc0_2(
          rt,
          rd,
          sel
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rt;
  public final Immediate rd;
  public final Immediate sel;

  public mfc0_2(final R rt, final Immediate rd, final Immediate sel) {
    this.rt = rt;
    this.rd = rd;
    this.sel = sel;

    addArgument("rt", rt);
    addArgument("rd", rd);
    addArgument("sel", sel);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("mfc0 %s, $%s, %d", rt.text(vars__), rd.access().load().toString(), sel.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("01000000000%5s%5s00000000%3s", rt.image(vars__), rd.access().load().toString(), sel.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    new add_exception(new Immediate(Data.valueOf(Type.CARD(8), 0x0))).execute(pe__, vars__);
    new CPRGET(new Immediate(Data.coerce(Type.CARD(8), Data.valueOf(DWORD, 0x8).multiply(Data.zeroExtend(DWORD, rd.access().load())).add(Data.zeroExtend(DWORD, sel.access().load()))))).execute(pe__, vars__);
    if ((Data.valueOf(DWORD, 0x8).multiply(Data.zeroExtend(DWORD, rd.access().load())).add(Data.zeroExtend(DWORD, sel.access().load())).equals(Data.valueOf(DWORD, 0x10)) || Data.valueOf(DWORD, 0x8).multiply(Data.zeroExtend(DWORD, rd.access().load())).add(Data.zeroExtend(DWORD, sel.access().load())).equals(Data.valueOf(DWORD, 0x18)))) {
      vars__.temp64.access().bitField(29, 0).store(vars__.tempCPR.access().bitField(29, 0).load());
      vars__.temp64.access().bitField(31, 31).store(vars__.tempCPR.access().bitField(63, 63).load());
      vars__.temp64.access().bitField(30, 30).store(vars__.tempCPR.access().bitField(62, 62).load());
      vars__.temp64.access().bitField(63, 32).store(Data.signExtend(WORD, vars__.tempCPR.access().bitField(63, 63).load()));
    } else {
      rt.access(pe__, vars__).store(Data.signExtend(DWORD, vars__.tempCPR.access().bitField(31, 0).load()));
    }
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}