/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.memory.Location;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class mips64_load_fpu_short extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "mips64_load_fpu_short",
          mips64_load_fpu_short.class,
          null
          );
      addArgument("load_op", Type.CARD(4));
      addArgument("rt", FR.INFO);
      addArgument("load_offset", SHORT);
      addArgument("load_base", R.INFO);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate load_op = (Immediate) getArgument("load_op", args);
      final FR rt = (FR) getArgument("rt", args);
      final Immediate load_offset = (Immediate) getArgument("load_offset", args);
      final R load_base = (R) getArgument("load_base", args);

      return new mips64_load_fpu_short(load_op, rt, load_offset, load_base);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate load_op;
  public final FR rt;
  public final Immediate load_offset;
  public final R load_base;

  public mips64_load_fpu_short(final Immediate load_op, final FR rt, final Immediate load_offset, final R load_base) {
    this.load_op = load_op;
    this.rt = rt;
    this.load_offset = load_offset;
    this.load_base = load_base;

    addArgument("load_op", load_op);
    addArgument("rt", rt);
    addArgument("load_offset", load_offset);
    addArgument("load_base", load_base);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.temp64.access().store(Data.signExtend(DWORD, load_offset.access().load()));
    new mips64_load_fpu(load_op, rt, new Immediate(vars__.temp64.access()), load_base).execute(pe__, vars__);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}