/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class mul_unsigned_words extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "mul_unsigned_words",
          mul_unsigned_words.class,
          null
          );
      addArgument("temp_a", WORD);
      addArgument("temp_b", WORD);}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate temp_a = (Immediate) getArgument("temp_a", args);
      final Immediate temp_b = (Immediate) getArgument("temp_b", args);

      return new mul_unsigned_words(temp_a, temp_b);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate temp_a;
  public final Immediate temp_b;

  public mul_unsigned_words(final Immediate temp_a, final Immediate temp_b) {
    this.temp_a = temp_a;
    this.temp_b = temp_b;

    addArgument("temp_a", temp_a);
    addArgument("temp_b", temp_b);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.temp64_1.access().store(Data.zeroExtend(DWORD, temp_a.access().bitField(31, 0).load()));
    vars__.temp64_2.access().store(Data.zeroExtend(DWORD, temp_b.access().bitField(31, 0).load()));
    vars__.temp64.access().store(vars__.temp64_1.access().load().multiply(vars__.temp64_2.access().load()));
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}