/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class puups_s extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "puups_s",
          puups_s.class,
          null
          );
      addArgument("fd", FR.INFO);
      addArgument("fs", FR.INFO);
      addArgument("ft", FR.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final FR fd = (FR) getArgument("fd", args);
      final FR fs = (FR) getArgument("fs", args);
      final FR ft = (FR) getArgument("ft", args);

      return new puups_s(fd, fs, ft);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "puups_s",
          instruction.class,
          null
          );
      addArgument("fd", FR.INFO);
      addArgument("fs", FR.INFO);
      addArgument("ft", FR.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final FR fd = (FR) getArgument("fd", args);
      final FR fs = (FR) getArgument("fs", args);
      final FR ft = (FR) getArgument("ft", args);

      return new instruction(
        new puups_s(
          fd,
          fs,
          ft
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final FR fd;
  public final FR fs;
  public final FR ft;

  public puups_s(final FR fd, final FR fs, final FR ft) {
    this.fd = fd;
    this.fs = fs;
    this.ft = ft;

    addArgument("fd", fd);
    addArgument("fs", fs);
    addArgument("ft", ft);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("puu.ps.s %s, %s, %s", fd.text(vars__), fs.text(vars__), ft.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("01000110110%5s%5s%5s101111", ft.image(vars__), fs.image(vars__), fd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    fd.access(pe__, vars__).bitField(63, 0).store(Location.concat(fs.access(pe__, vars__).bitField(63, 32), ft.access(pe__, vars__).bitField(63, 32)));
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}