/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class scd extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "scd",
          scd.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("offset", SHORT);
      addArgument("base", R.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final Immediate offset = (Immediate) getArgument("offset", args);
      final R base = (R) getArgument("base", args);

      return new scd(rt, offset, base);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "scd",
          instruction.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("offset", SHORT);
      addArgument("base", R.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final Immediate offset = (Immediate) getArgument("offset", args);
      final R base = (R) getArgument("base", args);

      return new instruction(
        new scd(
          rt,
          offset,
          base
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rt;
  public final Immediate offset;
  public final R base;

  public scd(final R rt, final Immediate offset, final R base) {
    this.rt = rt;
    this.offset = offset;
    this.base = base;

    addArgument("rt", rt);
    addArgument("offset", offset);
    addArgument("base", base);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("scd %s, %d(%s)", rt.text(vars__), offset.access().load().bigIntegerValue(), base.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("111100%5s%5s%16s", base.image(vars__), rt.image(vars__), offset.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    if (pe__.LLbit.access().load().equals(Data.valueOf(BIT, 0x1))) {
      new mips64_store(new Immediate(Data.valueOf(Type.CARD(4), 0x8)), rt, offset, base).execute(pe__, vars__);
    }
    rt.access(pe__, vars__).store(Data.valueOf(DWORD, 0x0));
    rt.access(pe__, vars__).bitField(1, 1).store(pe__.LLbit.access().load());
    pe__.LLbit.access().store(Data.valueOf(BIT, 0x0));
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}