/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class tlbwi extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "tlbwi",
          tlbwi.class,
          null
          );
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      return new tlbwi();
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "tlbwi",
          instruction.class,
          null
          );
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      return new instruction(
        new tlbwi()
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public tlbwi() {
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("tlbwi");
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("01000010000000000000000000000010");
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    new add_exception(new Immediate(Data.valueOf(Type.CARD(8), 0x0))).execute(pe__, vars__);
    new add_exception(new Immediate(Data.valueOf(Type.CARD(8), 0x3))).execute(pe__, vars__);
    vars__.temp_jtlb_index.access().store(pe__.C0_INDEX.access().load());
    vars__.temp_jtlb_entry_hi.access().store(pe__.C0_ENTRY_HI.access().load());
    vars__.temp_jtlb_entry_lo0.access().store(pe__.C0_ENTRY_LO0.access().load());
    vars__.temp_jtlb_entry_lo1.access().store(pe__.C0_ENTRY_LO1.access().load());
    vars__.temp_jtlb_entry.access().store(Location.concat(vars__.temp_jtlb_entry_hi.access(), vars__.temp_jtlb_entry_lo0.access().bitField(31, 0), vars__.temp_jtlb_entry_lo1.access().bitField(31, 0)));
    pe__.JTLB.access(vars__.temp_jtlb_index.access().load()).store(vars__.temp_jtlb_entry.access().load());
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}