/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class truncw_fmt extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "truncw_fmt",
          truncw_fmt.class,
          null
          );
      addArgument("op_fmt", FMT_FORMAT.INFO);
      addArgument("fd", FR.INFO);
      addArgument("fs", FR.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive op_fmt = (IsaPrimitive) getArgument("op_fmt", args);
      final FR fd = (FR) getArgument("fd", args);
      final FR fs = (FR) getArgument("fs", args);

      return new truncw_fmt(op_fmt, fd, fs);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "truncw_fmt",
          instruction.class,
          null
          );
      addArgument("op_fmt", FMT_FORMAT.INFO);
      addArgument("fd", FR.INFO);
      addArgument("fs", FR.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive op_fmt = (IsaPrimitive) getArgument("op_fmt", args);
      final FR fd = (FR) getArgument("fd", args);
      final FR fs = (FR) getArgument("fs", args);

      return new instruction(
        new truncw_fmt(
          op_fmt,
          fd,
          fs
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final IsaPrimitive op_fmt;
  public final FR fd;
  public final FR fs;

  public truncw_fmt(final IsaPrimitive op_fmt, final FR fd, final FR fs) {
    this.op_fmt = op_fmt;
    this.fd = fd;
    this.fs = fs;

    addArgument("op_fmt", op_fmt);
    addArgument("fd", fd);
    addArgument("fs", fs);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("trunc.w.%s %s, %s", op_fmt.text(vars__), fd.text(vars__), fs.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("010001%5s00000%5s%5s001101", op_fmt.image(vars__), fs.image(vars__), fd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    new cvtw_fmt(op_fmt, fd, fs).execute(pe__, vars__);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}