/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.decoder;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.vliw.TempVars;
import ru.ispras.microtesk.model.vliw.op.ABS_S;
import ru.ispras.microtesk.model.vliw.mode.F;

/**
 * The {@code DecoderABS_S} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderABS_S extends DecoderItem {
  private static DecoderABS_S instance = null;

  public static DecoderABS_S get() {
    if (null == instance) {
      instance = new DecoderABS_S();
    }
    return instance;
  }

  private DecoderABS_S() {
    super(
        32,
        true,
        "01000110000000000000000000000101",
        "11111111111111110000000000111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    F fd = null;
    F fs = null;

    if (!matchNextOpc(image, BitVector.valueOf("0100011000000000", 2, 16))) {
      return null;
    }
    fs = (F) readNextPrimitive(image, DecoderF.get());
    if (null == fs) {
      return null;
    }
    fd = (F) readNextPrimitive(image, DecoderF.get());
    if (null == fd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("000101", 2, 6))) {
      return null;
    }

    return newResult(new ABS_S(fd, fs));
  }
}
