/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86gnu.decoder;

import static ru.ispras.microtesk.model.x86gnu.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.x86gnu.TempVars;
import ru.ispras.microtesk.model.x86gnu.op.and_r8r8;
import ru.ispras.microtesk.model.x86gnu.mode.R8;

/**
 * The {@code DecoderAnd_r8r8} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderAnd_r8r8 extends DecoderItem {
  private static DecoderAnd_r8r8 instance = null;

  public static DecoderAnd_r8r8 get() {
    if (null == instance) {
      instance = new DecoderAnd_r8r8();
    }
    return instance;
  }

  private DecoderAnd_r8r8() {
    super(
        16,
        true,
        "0010001011000000",
        "1111111111000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R8 op1 = null;
    R8 op2 = null;

    if (!matchNextOpc(image, BitVector.valueOf("0010001011", 2, 10))) {
      return null;
    }
    op1 = (R8) readNextPrimitive(image, DecoderR8.get());
    if (null == op1) {
      return null;
    }
    op2 = (R8) readNextPrimitive(image, DecoderR8.get());
    if (null == op2) {
      return null;
    }

    return newResult(new and_r8r8(op1, op2));
  }
}
