/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86nasm.decoder;

import static ru.ispras.microtesk.model.x86nasm.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.x86nasm.TempVars;
import ru.ispras.microtesk.model.x86nasm.op.neg_r8;
import ru.ispras.microtesk.model.x86nasm.mode.R8;

/**
 * The {@code DecoderNeg_r8} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderNeg_r8 extends DecoderItem {
  private static DecoderNeg_r8 instance = null;

  public static DecoderNeg_r8 get() {
    if (null == instance) {
      instance = new DecoderNeg_r8();
    }
    return instance;
  }

  private DecoderNeg_r8() {
    super(
        16,
        true,
        "1111011011000000",
        "1111111111111000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    R8 op1 = null;

    if (!matchNextOpc(image, BitVector.valueOf("1111011011000", 2, 13))) {
      return null;
    }
    op1 = (R8) readNextPrimitive(image, DecoderR8.get());
    if (null == op1) {
      return null;
    }

    return newResult(new neg_r8(op1));
  }
}
